#include <math.h>
/**********************************************************************/
      int frootn(int n,double fx[],double xx[],double xn[],double x0[]
                ,double dx[],double err[],double flm[],int step[]
                ,double buf[],double (*fun)()) {
/*    int frootn(n,fx,xx,xn,x0,dx,err,flm,step,buf,fun)
      int n,step[]; double fx[],xx[],xn[],x0[],dx[],err[],flm[],buf[];
      double (*fun)(); {                                              */
/*    ============================================================    */
      int i,nstep=12;
      extern double xzero();
      --fx; --xx; --xn; --x0; --dx; --err; --flm; --step; --buf;
/*    ============================================================    */
      if(n != 3) {printf("for n=3 only\n"); exit(0);}
      for(i=1; i<=3; i++) xn[i]=x0[i];
/*    ------------------------------------ loop 1 for f_1(xx[1])=0    */
      step[1]=1;
  L10:xx[1]=xn[1];
/*    ------------------------------------ loop 2 for f_2(xx[2])=0    */
      step[2]=1;
  L20:xx[2]=xn[2];
/*    ------------------------------------ loop 3 for f_3(xx[3])=0    */
      step[3]=1;
  L30:xx[3]=xn[3];
      fx[3]=fun(&xx[1],3);
      xn[3]=xzero(xx[3],fx[3],dx[3],step[3],&buf[23]);
      if(fabs(xn[3]-xx[3]) <= err[3]) goto L110;
      if(fabs(fx[3]) > flm[3]) goto L310;
      step[3]=step[3]+1;
      if(step[3] <= nstep) goto L30;
/*    ---------------------------------------------- end of loop 3    */
 L110:fx[2]=fun(&xx[1],2);
      xn[2]=xzero(xx[2],fx[2],dx[2],step[2],&buf[12]);
      if(fabs(xn[2]-xx[2]) <= err[2]) goto L210;
      if(fabs(fx[2]) > flm[2]) goto L310;
      step[2]=step[2]+1;
      if(step[2] <= nstep) goto L20;
/*    ---------------------------------------------- end of loop 2    */
 L210:fx[1]=fun(&xx[1],1);
      xn[1]=xzero(xx[1],fx[1],dx[1],step[1],&buf[1]);
      if(fabs(xn[1]-xx[1]) <= err[1]) goto L310;
      if(fabs(fx[1]) > flm[1]) goto L310;
      step[1]=step[1]+1;
      if(step[1] <= nstep) goto L10;
/*    ---------------------------------------------- end of loop 1    */
 L310:return(0);
}
/**********************************************************************/
