#include <math.h>
/**********************************************************************/
      int search(double *pxx,double *pfx,double (*f)(),double xmin
                ,double xmax,double dx,int icut,double flmt) {
/*    int search(pxx,pfx,f,xmin,xmax,dx,icut,flmt)
      double *pxx,*pfx,(*f)(),xmin,xmax,dx,flmt; int icut; {          */
/*    ============================================================    */
      double fa,fb,fx,xa,xb,xx;
      int    ir,ie;
/*    ============================================================    */
      fa= 1.0;
      fb=-1.0;
      xx=xmin;
      ir=0;
/*    +----------------------------------------------------------+    */
/*    | compute function value                                   |    */
/*    +----------------------------------------------------------+    */
  L30:fx=f(xx);
      ir=ir+1;
      if(fx == 0.0) {*pxx=xx; *pfx=fx; return(0);}
/*    printf("\nir,fx,xx" %d,%15.6le,%15.6le",ir,fx,xx);              */
/*    +----------------------------------------------------------+    */
/*    | return on discontinuous point                            |    */
/*    +----------------------------------------------------------+    */
      if(fabs(fx) >= flmt) {*pxx=xx; *pfx=fx; return(0);}
/*    +----------------------------------------------------------+    */
/*    | set limits for next new root                             |    */
/*    +----------------------------------------------------------+    */
      if(fx < 0.0) {
        xa=xx;
        fa=fx;
      } else {
        xb=xx;
        fb=fx;
      }
/*    +----------------------------------------------------------+    */
/*    | search interval for changing sign                        |    */
/*    +----------------------------------------------------------+    */
      if(fa*fb > 0.0) {
        if(xx > xmax) {
          printf("\nNo root between %15.6le %15.6le",xmin,xmax);
          {*pxx=xx; *pfx=fx; return(0);}
        }
        xx=xx+dx;
        ie=ir+icut;
        goto L30;
      }
/*    +----------------------------------------------------------+    */
/*    | get new root by half interval method                     |    */
/*    +----------------------------------------------------------+    */
      xx=0.5*(xa+xb);
/*    +----------------------------------------------------------+    */
/*    | get new root by false position method                    |    */
/*    +----------------------------------------------------------+    */
/*L75:xx=xa-fa*(xb-xa)/(fb-fa)                                        */
/*    +----------------------------------------------------------+    */
/*    | check the iteration numbers                              |    */
/*    +----------------------------------------------------------+    */
      if(ir <= ie) goto L30;
      printf("\nThe number of iterations exceeds %d",icut);
      *pxx=xx; *pfx=fx; return(0);
}
/**********************************************************************/
