#include <stdio.h>
#include <ctype.h>
#include <math.h>
double f(double);
double g(double);
/**********************************************************************/
      main() {
/*    ============================================================    */
      double dx,fx,xn,xx,eps,xini,xfin,flmt;
      int    itmax;
      extern int froot(),groot(),sroot();
      extern double f(),g();
/*    ============================================================    */
      xini=1.0;
      xfin=2.0;
      dx  =0.1;
      eps =0.00001;
      itmax=12;
      flmt=1.0e30;
/*    ------------------------------------------------------------    */
      groot(&xn,&xx,g,xini,eps,itmax);
      printf("\n xn,xx =%13.5le,%13.5le\n",xn,xx);
      froot(&xx,&fx,f,xini,dx,eps,itmax,flmt);
      printf("\n xx,fx =%13.5le,%13.5le\n",xx,fx);
      sroot(&xx,&fx,f,xini,xfin,dx,eps,itmax,flmt);
      printf("\n xx,fx =%13.5le,%13.5le\n",xx,fx);
      exit(0);
}
/**********************************************************************/
      double f(double x) {
/*    double f(x) double x; {                                         */
/*    ============================================================    */
      double fun;
/*    ============================================================    */
      fun=x*x-3.0;
      if(fabs(fun) <= 0.00001) fun=0.0;
      return(fun);
}
/**********************************************************************/
      double g(double x) {
/*    double g(x) double x; {                                         */
/*    ============================================================    */
      double fun;
/*    ============================================================    */
      fun=0.5*(x+3.0/x);
      return(fun);
}
/**********************************************************************/
