#include <stdio.h>
#include <ctype.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
      double *a,*b,*p;
      int    *ll;
      int    maxa=2000,maxn=100;
      int    i,j,jb,ii,not,nlt,nnt,nsd;
/*    ============================================================    */
      a=(double *)malloc(maxa*sizeof(double));
      b=(double *)malloc(maxa*sizeof(double));
      p=(double *)malloc(maxn*sizeof(double));
      ll=(int   *)malloc(maxn*2*sizeof(int ));
      --a; --b; --ll; ll-=2;
/*    ============================================================    */
      if(argc<3) {printf("Usage : ustest infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ============================================================    */
  L10:freeii(&not,fp_r); if(not <= 0) exit(0); freeii(&nlt,fp_r);
      for(i=1; i<=not; i++) {
        freeii(&ll[1+i*2],fp_r);
        freeii(&ll[2+i*2],fp_r);
      }
      freer8(&a[1],fp_r);
      for(j=2; j<=not; j++) {
        for(i=ll[2+(j-1)*2]+j; i<=ll[2+j*2]+j; i++) freer8(&a[i],fp_r);
      }
      for(i=1; i<=not*nlt; i++) freer8(&b[i],fp_r);
/*    ------------------------------------------------------------    */
      fprintf(fp_w,"\n\nNOT,NLT:   %6d%6d",not,nlt);
      for(i=1; i<=not; i++) {
        if(i%10 == 1) fprintf(fp_w,"\nLL(2,NOT): ");
        fprintf(fp_w,"%6d%6d",ll[1+i*2],ll[2+i*2]);
      }
      fprintf(fp_w,"\nA(*,*):%12.6lE",a[1]);
      for(j=2; j<=not; j++) { ii=0;
        for(i=ll[2+(j-1)*2]+j; i<=ll[2+j*2]+j; i++) {
          if(++ii%6 == 1) fprintf(fp_w,"\nA(*,*):");
          fprintf(fp_w,"%12.6lE",a[i]);
        }
      }
      for(i=1; i<=not*nlt; i++) {
        if(i%6 == 1) fprintf(fp_w,"\nB(*,*):");
        fprintf(fp_w,"%12.6lE",b[i]);
      }
/*    ------------------------------------------------------------    */
      usdecp(&a[1],&ll[1+1*2],not,&nnt,&nsd,maxa,maxn);
/*    ------------------------------------------------------------    */
      fprintf(fp_w,"\nNOT,NNT,NSD%6d%6d%6d",not,nnt,nsd);
      for(i=1; i<=nnt; i++) {
        if(i%10 == 1) fprintf(fp_w,"\nLL(2,NNT): ");
        fprintf(fp_w,"%6d%6d",ll[1+i*2],ll[2+i*2]);
      }
      fprintf(fp_w,"\nU(*,*):%12.6lE",a[1]);
      for(j=2; j<=nnt; j++) { ii=0;
        for(i=ll[2+(j-1)*2]+j; i<=ll[2+j*2]+j; i++) {
          if(++ii%6 == 1) fprintf(fp_w,"\nU(*,*):");
          fprintf(fp_w,"%12.6lE",a[i]);
        }
      }
/*    ------------------------------------------------------------    */
      for(j=1; j<=nlt; j++) {
        jb=(j-1)*not;
        ussolx(&a[1],&b[1+jb],&ll[1+1*2],not,nnt,p);
        for(i=1; i<=not; i++) {
          if(i%6 == 1) fprintf(fp_w,"\nX(*,*):");
          fprintf(fp_w,"%12.6lE",b[i+jb]);
        }
      }
/*    ------------------------------------------------------------    */
      if(nsd > 0) {
        ussngx(&a[1],&b[1],&ll[1+1*2],not,nnt,nsd,p);
        for(j=1; j<=nsd; j++) {
          jb=(j-1)*not;
          for(i=1; i<=not; i++) {
            if(i%6 == 1) fprintf(fp_w,"\nS(*,*):");
            fprintf(fp_w,"%12.6lE",b[i+jb]);
          }
        }
      }
      goto L10;
}
/**********************************************************************/
