#include <stdio.h>
#include <ctype.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
      double *aka,*ama,*av,*w,*vv,*sks,*sms,*sv,*y,eps;
      int    *ll,n,mw,mt,id,nmax,nn,k;
/*    ============================================================    */
      if(argc<3) {printf("Usage : subsmn infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
  L10:freeii(&n,fp_r); if(n == 0) exit(0);
      freeii(&mw,fp_r); freeii(&mt,fp_r);
      freeii(&id,fp_r); freeii(&nmax,fp_r); freer8(&eps,fp_r);
      if(mt == 0) {mt=2*mw; if(mw>5) mt=mw+5; if(mt>n) mt=n;}
      if(nmax == 0) nmax=20;
      if(eps == 0.0) eps=0.000001;
/*    +----------------------------------------------------------+    */
/*    | dynamic allocates the arrays                             |    */
/*    +----------------------------------------------------------+    */
      ll=(int *)calloc(n,sizeof(int));
      for(k=0; k<n; k++) freeii(&ll[k],fp_r);
      nn=ll[n-1]+n-ll[0];
      aka=(double *)calloc(nn            ,sizeof(double));
      ama=(double *)calloc(nn*id+n*(1-id),sizeof(double));
      av =(double *)calloc(n*mt          ,sizeof(double));
      w  =(double *)calloc(mt            ,sizeof(double));
      vv =(double *)calloc(n             ,sizeof(double));
      sks=(double *)calloc(mt*(mt+1)/2   ,sizeof(double));
      sms=(double *)calloc(mt*(mt+1)/2   ,sizeof(double));
      sv =(double *)calloc(mt*mt         ,sizeof(double));
      y  =(double *)calloc(mt            ,sizeof(double));
/*    +----------------------------------------------------------+    */
/*    | input aka(n,n),ama(n,n)                                  |    */
/*    | compute and output av(n,mw),w(mw)                        |    */
/*    +----------------------------------------------------------+    */
      input(ll,aka,ama,n,id,fp_r);
      subspc(ll,aka,ama,av,w,n,mt,mw,vv,sks,sms,sv,y,id,nmax,eps,fp_w);
      output(av,w,n,mw,fp_w);
      free(ll); free(aka); free(ama); free(av); free(w);
      free(vv); free(sks); free(sms); free(sv); free(y);
      goto L10;
}
/**********************************************************************/
      int input(int ll[],double aka[],double ama[]
               ,int n,int id,FILE *fp_r) {
/*    int input(ll,aka,ama,n,id,fp_r)
      double aka[],ama[]; int ll[],n,id; FILE *fp_r; {                */
/*    ============================================================    */
      int    k,nn;
/*    ============================================================    */
/*    for(k=0; k<n; k++) freeii(&ll[k],fp_r);                         */
      nn=ll[n-1]+n-ll[0];
      for(k=0; k<nn; k++) freer8(&aka[k],fp_r);
      nn=nn*id+n*(1-id);
      for(k=0; k<nn; k++) freer8(&ama[k],fp_r);
      return(0);
}
/**********************************************************************/
      int output(double av[],double w[],int n,int mw,FILE *fp_w) {
/*    int output(av,w,n,mw,fp_w)
      double av[],w[]; int n,mw; FILE *fp_w; {                        */
/*    ============================================================    */
      int    i,j;
/*    ============================================================    */
/*    output eigenvalues w(mw) and eigenvectors a(n,mw)               */
/*    ============================================================    */
      for(j=0; j<mw; j++) {
        fprintf(fp_w,"\n Eigenvalue =%13.4le, eigenvector :\n\n",w[j]);
        for(i=0; i<n; i++) fprintf(fp_w,"%13.4le",av[i+j*n]);
        fprintf(fp_w,"\n");
      }
      return(0);
}
/**********************************************************************/
