/**********************************************************************/
      int heapl(double a[],int l[],int n) {
/*    int heapl(a,l,n) double a[]; int l[],n; {                       */
/*    ============================================================    */
      int i,k,m,lx; int shiftl();
      --a; --l;
/*    ============================================================    */
/*    heap sort : after sorting  a(l(i)) <= a(l(i+1))                 */
/*    ============================================================    */
      for(i=1; i<=n; i++) {
        l[i]=i;
      }
/*    +----------------------------------------------------------+    */
/*    | form heap (a(l(i)),i=k,n) for k=n/2 ... 1                |    */
/*    +----------------------------------------------------------+    */
      for(k=n/2; k>=1; k--) {
        lx=l[k];
        shiftl(&a[1],&l[1],k,n,lx);
      }
/*    +----------------------------------------------------------+    */
/*    | put max of a(l(1:m)) in the correct position m           |    */
/*    | form heap (a(l(i)),i=1,m-1) for m=n ... 2                |    */
/*    +----------------------------------------------------------+    */
      for(m=n; m>=2; m--) {
        lx=l[m];
        l[m]=l[1];
        shiftl(&a[1],&l[1],1,m-1,lx);
      }
      return(0);
}
/**********************************************************************/
      int shiftl(double a[],int l[],int k,int m,int lx) {
/*    int shiftl(a,l,k,m,lx) double a[]; int l[],k,m,lx; {            */
/*    ============================================================    */
      int i,j;
      --a; --l;
/*    ============================================================    */
/*    given lx and heap a(l(k+1:m))  where  k  <=  m                  */
/*    shift a(lx) down to form new heap a(l(k:m))                     */
/*    a: a(l(i)) >= a(l(2*i))  &&  a(l(i)) >= a(l(2*i+1))             */
/*    ============================================================    */
      i=k;
  L60:j=i+i;
      if(j <= m) {
        if(j < m) {
          if(a[l[j+1]] > a[l[j]]) j=j+1;
        }
        if(a[l[j]] > a[lx]) {
/*        +------------------------------------------------------+    */
/*        | shift a(lx) down to position j                       |    */
/*        +------------------------------------------------------+    */
          l[i]=l[j];
          i=j;
          goto L60;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | no more shift down : i is the correct position for a(lx) |    */
/*    +----------------------------------------------------------+    */
      l[i]=lx;
      return(0);
}
/**********************************************************************/
