/* #define STABLE */
/* #define DECEND */
extern struct { double a[1025]; } extkey;
extern struct { int    l[1025]; } extind;
       struct { int    lx;      } intind;
/**********************************************************************/
      int icmpij(int i,int j) {
/*    int icmpij(i,j) int i,j; {                                      */
/*    ============================================================    */
      int icmp;
/*    ============================================================    */
/*    for stable sorting by heapg or quickg                           */
/*        change cstable to blanks                                    */
/*    ============================================================    */
#ifdef STABLE
      if(extkey.a[extind.l[i]] != extkey.a[extind.l[j]]) {
#endif
/*        +------------------------------------------------------+    */
/*        | for decending index sorting                          |    */
/*        +------------------------------------------------------+    */
#ifdef DECEND
          icmp = extkey.a[extind.l[i]] >= extkey.a[extind.l[j]];
#else
/*        +------------------------------------------------------+    */
/*        | for ascending index sorting                          |    */
/*        +------------------------------------------------------+    */
          icmp = extkey.a[extind.l[i]] <= extkey.a[extind.l[j]];
#endif
#ifdef STABLE
      } else {
          icmp = extind.l[i] <= extind.l[j];
      }
#endif
      return(icmp);
}
/**********************************************************************/
      int  icmpix(int i) {
/*    int  icmpix(i) int i; {                                         */
/*    ============================================================    */
      int icmp;
/*    ============================================================    */
/*    for stable sorting by heapg or quickg                           */
/*        change cstable to blanks                                    */
/*    ============================================================    */
#ifdef STABLE
      if(extkey.a[extind.l[i]] != a(lx)) {
#endif
/*        +------------------------------------------------------+    */
/*        | for decending index sorting                          |    */
/*        +------------------------------------------------------+    */
#ifdef DECEND
          icmp = extkey.a[extind.l[i]] >= extkey.a[intind.lx];
#else
/*        +------------------------------------------------------+    */
/*        | for ascending index sorting                          |    */
/*        +------------------------------------------------------+    */
          icmp = extkey.a[extind.l[i]] <= extkey.a[intind.lx];
#endif
#ifdef STABLE
      } else {
          icmp = extind.l[i] <= intind.lx;
      }
#endif
      return(icmp);
}
/**********************************************************************/
      int  icmpxj(int j) {
/*    int  icmpxj(j) int j; {                                         */
/*    ============================================================    */
      int icmp;
/*    ============================================================    */
/*    for stable sorting by heapg or quickg                           */
/*        change cstable to blanks                                    */
/*    ============================================================    */
#ifdef STABLE
       if(extkey.a[intind.lx] != extkey.a[extind.l[j]]) {
#endif
/*        +------------------------------------------------------+    */
/*        | for decending index sorting                          |    */
/*        +------------------------------------------------------+    */
#ifdef DECEND
          icmp = extkey.a[intind.lx] >= extkey.a[extind.l[j]];
#else
/*        +------------------------------------------------------+    */
/*        | for ascending index sorting                          |    */
/*        +------------------------------------------------------+    */
          icmp = extkey.a[intind.lx] <= extkey.a[extind.l[j]];
#endif
#ifdef STABLE
      } else {
          icmp = intind.lx <= extind.l[j];
      }
#endif
      return(icmp);
}
/**********************************************************************/
      int moveij(int i,int j) {
/*    int moveij(i,j) int i,j; {                                      */
/*    ============================================================    */
/*    for index sorting                                               */
/*    ============================================================    */
      extind.l[i]=extind.l[j];
      return(0);
}
/**********************************************************************/
      int moveix(int i) {
/*    int moveix(i) int i; {                                          */
/*    ============================================================    */
/*    for index sorting                                               */
/*    ============================================================    */
      extind.l[i]=intind.lx;
      return(0);
}
/**********************************************************************/
      int movexj(int j) {
/*    int movexj(j) int j; {                                          */
/*    ============================================================    */
/*    for index sorting                                               */
/*    ============================================================    */
      intind.lx=extind.l[j];
      return(0);
}
/**********************************************************************/
      int swapij(int i,int j) {
/*    int swapij(i,j) int i,j; {                                      */
/*    ============================================================    */
      int lt;
/*    ============================================================    */
/*    for index sorting                                               */
/*    ============================================================    */
      lt=extind.l[i];
      extind.l[i]=extind.l[j];
      extind.l[j]=lt;
      return(0);
}
/**********************************************************************/
      int rotxij(int i,int j) {
/*    int rotxij(i,j) int i,j; {                                      */
/*    ============================================================    */
/*    for index sorting                                               */
/*    ============================================================    */
      extind.l[i]=extind.l[j];
      extind.l[j]=intind.lx;
      intind.lx=extind.l[i];
      return(0);
}
/**********************************************************************/
      int initil(int n) {
/*    int initil(n) int n; {                                          */
/*    ============================================================    */
      int i;
/*    ============================================================    */
/*    for index sorting                                               */
/*    ============================================================    */
      for(i=1; i<=n; i++) extind.l[i]=i;
      return(0);
}
/**********************************************************************/
