/* #define DECEND */
extern struct { double a[1025]; } extkey;
       struct { double ax;      } intink;
/**********************************************************************/
      int icmpij(int i,int j) {
/*    int icmpij(i,j) int i,j; {                                      */
/*    ============================================================    */
      int icmp;
/*    +----------------------------------------------------------+    */
/*    | for decending key sorting                                |    */
/*    +----------------------------------------------------------+    */
#ifdef DECEND
      icmp = extkey.a[i] >= extkey.a[j];
#else
/*    +----------------------------------------------------------+    */
/*    | for ascending key sorting                                |    */
/*    +----------------------------------------------------------+    */
      icmp = extkey.a[i] <= extkey.a[j];
#endif
      return(icmp);
}
/**********************************************************************/
      int  icmpix(int i) {
/*    int  icmpix(i) int i; {                                         */
/*    ============================================================    */
      int icmp;
/*    +----------------------------------------------------------+    */
/*    | for decending key sorting                                |    */
/*    +----------------------------------------------------------+    */
#ifdef DECEND
      icmp = extkey.a[i] >= intink.ax;
#else
/*    +----------------------------------------------------------+    */
/*    | for ascending key sorting                                |    */
/*    +----------------------------------------------------------+    */
      icmp = extkey.a[i] <= intink.ax;
#endif
      return(icmp);
}
/**********************************************************************/
      int  icmpxj(int j) {
/*    int  icmpxj(j) int j; {                                         */
/*    ============================================================    */
      int icmp;
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | for decending key sorting                                |    */
/*    +----------------------------------------------------------+    */
#ifdef DECEND
      icmp = intink.ax >= extkey.a[j];
#else
/*    +----------------------------------------------------------+    */
/*    | for ascending key sorting                                |    */
/*    +----------------------------------------------------------+    */
      icmp = intink.ax <= extkey.a[j];
#endif
      return(icmp);
}
/**********************************************************************/
      int moveij(int i,int j) {
/*    int moveij(i,j) int i,j; {                                      */
/*    ============================================================    */
/*    for key sorting                                                 */
/*    ============================================================    */
      extkey.a[i]=extkey.a[j];
      return(0);
}
/**********************************************************************/
      int moveix(int i) {
/*    int moveix(i) int i; {                                          */
/*    ============================================================    */
/*    for key sorting                                                 */
/*    ============================================================    */
      extkey.a[i]=intink.ax;
      return(0);
}
/**********************************************************************/
      int movexj(int j) {
/*    int movexj(j) int j; {                                          */
/*    ============================================================    */
/*    for key sorting                                                 */
/*    ============================================================    */
      intink.ax=extkey.a[j];
      return(0);
}
/**********************************************************************/
      int swapij(int i,int j) {
/*    int swapij(i,j) int i,j; {                                      */
/*    ============================================================    */
      double at;
/*    ============================================================    */
/*    for key sorting                                                 */
/*    ============================================================    */
      at=extkey.a[i];
      extkey.a[i]=extkey.a[j];
      extkey.a[j]=at;
      return(0);
}
/**********************************************************************/
      int rotxij(int i,int j) {
/*    int rotxij(i,j) int i,j; {                                      */
/*    ============================================================    */
/*    for key sorting                                                 */
/*    ============================================================    */
      extkey.a[i]=extkey.a[j];
      extkey.a[j]=intink.ax;
      intink.ax=extkey.a[i];
      return(0);
}
/**********************************************************************/
      int initil(int n) {
/*    int initil(n) int n; {                                          */
/*    ============================================================    */
/*    for key sorting                                                 */
/*    ============================================================    */
      return(0);
}
/**********************************************************************/
