#include <math.h>
/**********************************************************************/
      int quick(double a[],int n) {
/*    int quick(a,n) double a[]; int n; {                             */
/*    ============================================================    */
      double ax,at;
      int i,j,k,m,nn,ix,il[21],iu[21];
      int i1,j1,k1,ii,jj,kk,jh,kh,jp,kp,mm;
      --a;
/*    ============================================================    */
/*    quick sort : after sorting  a(i) <= a(i+1)                      */
/*    il(nn),iu(nn) permit sorting up to n=2**(nn+1)-1                */
/*    ============================================================    */
      i=1;
      m=n;
      nn=1;
/*    ------------------------------------------------------------    */
      ii=i;
      mm=m;
/*    +----------------------------------------------------------+    */
/*    | sorting a(i:m) by partition into a(i:k) and a(j:m)       |    */
/*    +----------------------------------------------------------+    */
  L10:if(m-i < 15) goto L90;    /* 15 >= (6+1)/2 */
      ix=(i+m)/2;
      j=i+6;
      k=m-6;
/*    ------------------------------------------------------------    */
      jh=j-2;                    /* 2 = (6-1)/2 */
      kh=k+2;                    /* 2 = (6-1)/2 */
      j1=j+1;
      k1=k-1;
/*    +----------------------------------------------------------+    */
/*    | first make heaps a(i:j) and a(k:m)                       |    */
/*    | and get ax=mid(a(i:j),a(ix),a(k:m))                      |    */
/*    +----------------------------------------------------------+    */
/*    | make a heap a(i:j)                                       |    */
/*    | ii <= 0  if a(i:j) is already a heap                     |    */
/*    +----------------------------------------------------------+    */
      if(ii <= 0) goto L40;
      do {
        jp=jh;
        ax=a[jp];
        do {
          jj=jp+jp-j1;
          if(jj < i) break;
          if(jj > i) {if(a[jj] < a[jj-1]) jj=jj-1;}
          if(a[jj] <= ax) break;
          a[jp]=a[jj];
          jp=jj;
        } while(1);
        a[jp]=ax;
        jh=jh+1;
      } while(jh <= j);
      ii=-ii;
/*    +----------------------------------------------------------+    */
/*    | make a heap a(k:m)                                       |    */
/*    | mm <= 0  if a(k:m) is already a haep                     |    */
/*    +----------------------------------------------------------+    */
  L40:if(mm <= 0) goto L50;
      do {
        kp=kh;
        ax=a[kp];
        do {
          kk=kp+kp-k1;
          if(kk > m) break;
          if(kk < m) {if(a[kk] > a[kk+1]) kk=kk+1;}
          if(a[kk] >= ax) break;
          a[kp]=a[kk];
          kp=kk;
        } while(1);
        a[kp]=ax;
        kh=kh-1;
      } while(kh >= k);
      mm=-mm;
/*    ------------------------------------------------------------    */
  L50:ax=a[ix];
      if(ax > a[k]) goto L71;
/*    +----------------------------------------------------------+    */
/*    | shift a(ix) down to heap a(i:j)                          |    */
/*    +----------------------------------------------------------+    */
  L60:if(a[j] <= ax) goto L84;
      jp=j;
      a[ix]=a[jp];
      do {
        jj=jp+jp-j1;
        if(jj < i) break;
        if(jj > i) {if(a[jj] < a[jj-1]) jj=jj-1;}
        if(a[jj] <= ax) break;
        a[jp]=a[jj];
        jp=jj;
      } while(1);
      a[jp]=ax;
      ax=a[ix];
/*    goto L70                                                        */
/*    +----------------------------------------------------------+    */
/*    | shift a(ix) down to heap a(k:m)                          |    */
/*    +----------------------------------------------------------+    */
  L70:if(ax <= a[k]) goto L84;
  L71:kp=k;
      a[ix]=a[kp];
      do {
        kk=kp+kp-k1;
        if(kk > m) break;
        if(kk < m) {L73:if(a[kk] > a[kk+1]) kk=kk+1;}
        if(a[kk] >= ax) break;
        a[kp]=a[kk];
        kp=kk;
      } while(1);
      a[kp]=ax;
      ax=a[ix];
      goto L60;
/*    ============================================================    */
/*    subroutine partition(a,i,m,j,k,ax)                              */
/*    ============================================================    */
/*    such that  i <= k < j <= m  provided i < m                      */
/*    a(x) <= ax  for  i <= x <= k                                    */
/*    a(x)  = ax  for  k <  x <  j                                    */
/*    a(x) >= ax  for  j <= x <= m                                    */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | test right part for a(k)>ax & left part for a(j)<ax      |    */
/*    +----------------------------------------------------------+    */
  L84:k=k-1;
      if(a[k] > ax) goto L84;
  L85:j=j+1;
      if(a[j] < ax) goto L85;
/*    ------------------------------------------------------------    */
      if(j <= k) {
        at=a[j];
        a[j]=a[k];
        a[k]=at;
        goto L84;
      }
/*    +----------------------------------------------------------+    */
/*    | end of partitioning : find longer partition to save      |    */
/*    +----------------------------------------------------------+    */
      if(k-i > m-j) {
/*      +--------------------------------------------------------+    */
/*      | save  left partition a(i:k) then sort a(j:m)           |    */
/*      +--------------------------------------------------------+    */
        il[nn]=ii;
        iu[nn]=k;
        nn=nn+1;
        i=j;
        ii=i;
      } else {
/*      +--------------------------------------------------------+    */
/*      | save right partition a(j:m) then sort a(i:k)           |    */
/*      +--------------------------------------------------------+    */
        il[nn]=j;
        iu[nn]=mm;
        nn=nn+1;
        m=k;
        mm=m;
      }
      goto L10;
/*    +----------------------------------------------------------+    */
/*    | get a saved partition a(i:m) for sorting                 |    */
/*    +----------------------------------------------------------+    */
  L87:nn=nn-1;
      if(nn == 0) return(0);
      ii=il[nn];
      mm=iu[nn];
      i=abs(ii);
      m=abs(mm);
      goto L10;
/*    +----------------------------------------------------------+    */
/*    | use shaker sort for short key array                      |    */
/*    +----------------------------------------------------------+    */
  L90:jj=i;
  L92:if(jj >= m) goto L87;
      jj=jj+1;
      if(a[jj-1] <= a[jj]) goto L92;
      kk=jj;
      ax=a[kk];
  L94:a[kk]=a[kk-1];
      kk=kk-1;
      if(kk <= i) goto L95;
      if(a[kk-1] > ax) goto L94;
/*    ------------------------------------------------------------    */
  L95:a[kk]=ax;
      goto L92;
}
/**********************************************************************/
