/**********************************************************************/
      int sequns(double a[],int l[],int n) {
/*    int sequns(a,l,n) double a[]; int l[],n; {                      */
/*    ============================================================    */
      double ax; int i,j,k;
      --a; --l;
/*    ============================================================    */
/*    new.a(i) = old.a(l(i))                                          */
/*    ============================================================    */
/*    this subroutine is equivalent to                                */
/*    ------------------------------------------------------------    */
/*    for(i=1; i<=n; i++) b[i]=a[i];                                  */
/*    for(i=1; i<=n; i++) a[i]=b[l[i]];                               */
/*    return(0);                                                      */
/*    ------------------------------------------------------------    */
/*    it doesn't use working array b(n) but takes more time           */
/*    ============================================================    */
      for(i=1; i<=n; i++) {
        if(l[i] <= 0) goto L90;
        ax=a[i];
        j=i;
        do {
          k=l[j];
          l[j]=-k;
          if(k == i) break;
          a[j]=a[k];
          j=k;
        } while(1);
        a[j]=ax;
  L90:  l[i]=-l[i];
      }
      return(0);
}
/**********************************************************************/
