#include <math.h>
/**********************************************************************/
      double gauss2(double amean,double sigma) {
/*    double gauss2(amean,sigma) double amean,sigma; {                */
/*    ============================================================    */
      double u1,u2,rr,fun; int i; double random();
      static long ix=11111;
/*    ============================================================    */
/*    gauss  = normal distributed random number                       */
/*    amean  = mean value of the random number                        */
/*    sigma  = standard diviation of the random number                */
/*           = sqrt(variance)                                         */
/*    ------------------------------------------------------------    */
/*    ur     = random(&ix)                                            */
/*    ua     = random(&ix)                                            */
/*    gauss2 = amean + sigma * sqrt(-2* log(ur))*cos(6.2831853*ua)    */
/*    ------------------------------------------------------------    */
/*    note that : ur (0:1) can be replaced by rr  (rr=u1*u1+u2*u2)    */
/*                cos(6.2831853*ua) can be replaced by u1/sqrt(rr)    */
/*    ============================================================    */
      do {
        u1 = random(&ix)*2.0 - 1.0;
        u2 = random(&ix);
        rr = u1*u1 + u2*u2;
      } while(rr > 1.0);
      fun = amean + sigma * sqrt(-2.0*log(rr)/rr)*u1;
      return(fun);
}
/**********************************************************************/
