************************************************************************
      PROGRAM F2C
C**   ============================================================    **
      CHARACTER FILE*80
      CHARACTER LINE*255,LINN*255,AA(200)*8
      DIMENSION LL(200)
      DATA IN,IW/1,2/
C**   ============================================================    **
    5 WRITE(*,'('' Please input NAME of file NAME.for : '',$)')
      READ (*,'(A)',END=90) FILE
      CALL FILEIO(FILE,'FOR',INAME)
      IF(INAME.EQ.0) STOP
C**   +----------------------------------------------------------+    **
C**   | Open input file *.XIN, *.XOU                             |    **
C**   +----------------------------------------------------------+    **
      CLOSE(IN)
      CLOSE(IW)
      OPEN (IN,FILE=FILE,STATUS='OLD'
     *        ,FORM='FORMATTED',ACCESS='SEQUENTIAL')
      OPEN (IW,FILE=FILE(1:INAME)//'.CC',STATUS='UNKNOWN'
     *        ,FORM='FORMATTED',ACCESS='SEQUENTIAL')
C**   +----------------------------------------------------------+    **
C**   | read line                                                |    **
C**   +----------------------------------------------------------+    **
      IEOF=0
      READ (IN,'(A)') LINN
   10 LINE=LINN
      READ (IN,'(A)',END=15) LINN
      GO TO 20
   15 IF(IEOF.EQ.1) GO TO 5
      IEOF=1
      LINN=' '
C**   +----------------------------------------------------------+    **
C**   | to lower case                                            |    **
C**   +----------------------------------------------------------+    **
   20 CONTINUE
C**   CALL TOLOW(LINE)
C**   +----------------------------------------------------------+    **
C**   | continuation line                                        |    **
C**   +----------------------------------------------------------+    **
      IF(LINE(1:1).NE.'C'.AND.LINE(1:1).NE.'*') LINE(6:6)=' '
C**   +----------------------------------------------------------+    **
C**   | statement type                                           |    **
C**   +----------------------------------------------------------+    **
      CALL STTYPE(LINE,LINN,AA,LL,NA)
C**   +----------------------------------------------------------+    **
C**   | .ge. .gt. .le. .lt. .eq. .ne. .or. .and.  abs            |    **
C**   |  >=   >    <=   <    ==   !=   ||   &&    fabs           |    **
C**   +----------------------------------------------------------+    **
      CALL CHANGE(LINE)
C**   +----------------------------------------------------------+    **
C**   | array(i) --> array[i]                                    |    **
C**   +----------------------------------------------------------+    **
      CALL ARRAYS(LINE,AA,LL,NA)
C**   +----------------------------------------------------------+    **
C**   | ! comment --> /* comment */                              |    **
C**   +----------------------------------------------------------+    **
      LEN=LEN_TRIM(LINE)
      J=INDEX(LINE(1:LEN),'! ')
      IF(J.NE.0) LINE(J:LEN+4)='/*'//LINE(J+1:LEN)//' */'
C**   +----------------------------------------------------------+    **
C**   | label #  --> L#:                                         |    **
C**   +----------------------------------------------------------+    **
      I=1
   30 IF(LINE(I:I).GE.'1'.AND.LINE(I:I).LE.'9') THEN
        IF(I.GE.2) THEN
          IF(LINE(I-1:I-1).EQ.' ') THEN
            LINE(I-1:I-1)='L'
            LINE(6:6)=':'
          ENDIF
        ELSE
          LINE(6:6)=':'
          LINE='L'//LINE
        ENDIF
      ELSE
        I=I+1
        IF(I.LE.5) GO TO 30
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | write line                                               |    **
C**   +----------------------------------------------------------+    **
      WRITE(IW,'(A)') LINE(1:LEN_TRIM(LINE))
      GO TO 10
   90 STOP
      END
************************************************************************
      SUBROUTINE STTYPE(LINE,LINN,AA,LL,NA)
C**   ============================================================    **
      CHARACTER LINE*255,LINN*255,AA(200)*8,F(5)*20,FIELD*255
      DIMENSION LL(200),L(5)
C**   ============================================================    **
      LEN=LEN_TRIM(LINE)
C**   +----------------------------------------------------------+    **
C**   | comment                                                  |    **
C**   +----------------------------------------------------------+    **
      IF(LINE(1:1).EQ.'C'.OR.LINE(1:1).EQ.'*') THEN
        LINE( 1: 2)='/*'
        LINE(71:72)='*/'
        IF(LINE(3:3).EQ.'*'.AND.LINE(4:4).NE.'*') LINE(3:3)=' '
        RETURN
      ENDIF
      I=6
   10 I=I+1
      IF(I.GT.LEN) RETURN
      IF(LINE(I:I).EQ.' ') GO TO 10
      ISTR=I
C**   +----------------------------------------------------------+    **
C**   | program : no !                                           |    **
C**   +----------------------------------------------------------+    **
      IF(LINE(I:I+6).EQ.'PROGRAM') THEN
        LINE(1:255)='      main() {'
        NA=0
C**   +----------------------------------------------------------+    **
C**   | subroutine                                               |    **
C**   +----------------------------------------------------------+    **
      ELSE IF(LINE(I:I+9).EQ.'SUBROUTINE') THEN
        LINE(1:255)='      int'//LINE(I+10:LEN)
        CALL ADTYPE(LINE,LINN)
        NA=0
C**   +----------------------------------------------------------+    **
C**   | function                                                 |    **
C**   +----------------------------------------------------------+    **
      ELSE IF(LINE(I:I+7).EQ.'FUNCTION') THEN
        LINE(1:255)='      double'//LINE(I+8:LEN)
        CALL ADTYPE(LINE,LINN)
        NA=0
C**   +----------------------------------------------------------+    **
C**   | endif                                                    |    **
C**   +----------------------------------------------------------+    **
      ELSE IF(LINE(I:I+4).EQ.'ENDIF') THEN
        LINE(I:I+4)='}'
C**   +----------------------------------------------------------+    **
C**   | end                                                      |    **
C**   +----------------------------------------------------------+    **
      ELSE IF(LINE(I:I+2).EQ.'END') THEN
        LINE(1:1)='}'
        LINE(I:I+2)=' '
C**   +----------------------------------------------------------+    **
C**   | continue                                                 |    **
C**   +----------------------------------------------------------+    **
      ELSE IF(LINE(I:I+8).EQ.'CONTINUE') THEN
        LINE(I:I+8)='}'
        LINE(1:6)=' '    ! erase the label #
C**   +----------------------------------------------------------+    **
C**   | do                                                       |    **
C**   +----------------------------------------------------------+    **
      ELSE IF(LINE(I:I+2).EQ.'DO ') THEN
        J=INDEX(LINE(1:LEN),'! ')
        IF(J.NE.0) FIELD=LINE(J:LEN)
        ISTAR=I+2
        DO 20 K=1,5
          CALL DATFLD(LINE,LEN,ISTAR,IBEGN,ISTOP,F(K),ITYPE)
          L(K)=ISTOP-IBEGN+1
   20   CONTINUE
        IF(L(5).EQ.0) THEN
          LINE(I:255)='for('//F(2)(1:L(2))//F(3)(1:L(3))//'; '
     *              //F(2)(1:L(2)-1)//'<='//F(4)(1:L(4))//'; '
     *              //F(2)(1:L(2)-1)//'++) {'
        ELSE IF(F(5)(1:2).EQ.'-1') THEN
          LINE(I:255)='for('//F(2)(1:L(2))//F(3)(1:L(3))//'; '
     *              //F(2)(1:L(2)-1)//'>='//F(4)(1:L(4))//'; '
     *              //F(2)(1:L(2)-1)//'--) {'
        ELSE IF(F(5)(1:1).NE.'-') THEN
          LINE(I:255)='for('//F(2)(1:L(2))//F(3)(1:L(3))//'; '
     *              //F(2)(1:L(2)-1)//'<='//F(4)(1:L(4))//'; '
     *    //F(2)(1:L(2))//F(2)(1:L(2)-1)//'+'//F(5)(1:L(5))//') {'
        ELSE
          LINE(I:255)='for('//F(2)(1:L(2))//F(3)(1:L(3))//'; '
     *              //F(2)(1:L(2)-1)//'>='//F(4)(1:L(4))//'; '
     *    //F(2)(1:L(2))//F(2)(1:L(2)-1)//F(5)(1:L(5))//') {'
        ENDIF
        IF(J.NE.0) LINE(1:255)=LINE(1:LEN_TRIM(LINE))//'  '//FIELD
C**   +----------------------------------------------------------+    **
C**   | else if                                                  |    **
C**   +----------------------------------------------------------+    **
      ELSE IF(LINE(I:I+6).EQ.'ELSE IF') THEN
        I=I
C**   +----------------------------------------------------------+    **
C**   | else                                                     |    **
C**   +----------------------------------------------------------+    **
      ELSE IF(LINE(I:I+3).EQ.'ELSE') THEN
        LINE(I:LEN+4)='} else {'//LINE(I+4:LEN)
C**   +----------------------------------------------------------+    **
C**   | return                                                   |    **
C**   +----------------------------------------------------------+    **
C     ELSE IF(LINE(I:I+5).EQ.'RETURN') THEN
C       LINE(I:LEN+4)='return(0);'//LINE(I+6:LEN)
C**   +----------------------------------------------------------+    **
C**   | exit                                                     |    **
C**   +----------------------------------------------------------+    **
C     ELSE IF(LINE(I:I+3).EQ.'EXIT') THEN
C       LINE(I:LEN+2)='break;'//LINE(I+4:LEN)
C**   +----------------------------------------------------------+    **
C**   | stop                                                     |    **
C**   +----------------------------------------------------------+    **
C     ELSE IF(LINE(I:I+3).EQ.'STOP') THEN
C       LINE(I:LEN+4)='exit(0);'//LINE(I+4:LEN)
C**   +----------------------------------------------------------+    **
C**   | call : no !                                              |    **
C**   +----------------------------------------------------------+    **
C     ELSE IF(LINE(I:I+3).EQ.'CALL') THEN
C       LINE(I:LEN)=LINE(I+5:LEN)//';'
C**   +----------------------------------------------------------+    **
C**   | dimension : no !                                         |    **
C**   +----------------------------------------------------------+    **
      ELSE IF(LINE(I:I+8).EQ.'DIMENSION'.OR.
     *        LINE(I:I+8).EQ.'CHARACTER'.OR.
     *        LINE(I:I+6).EQ.'INTEGER') THEN
        ISTAR=I+7
   30   IF(ISTAR.LE.LEN) THEN
          CALL DATFLD(LINE,LEN,ISTAR,IBEGN,ISTOP,FIELD,ITYPE)
          IF(ITYPE.EQ.4) THEN
            NA=NA+1
            AA(NA)=LINE(IBEGN:ISTOP)
            LL(NA)=ISTOP-IBEGN+1
          ENDIF
          GO TO 30
        ENDIF
        IF(LINE(I:I).EQ.'D') LINE(I:LEN)='double'//LINE(I+9:LEN)//';'
        IF(LINE(I:I).EQ.'C') LINE(I:LEN)='char  '//LINE(I+9:LEN)//';'
        IF(LINE(I:I).EQ.'I') LINE(I:LEN)='int   '//LINE(I+7:LEN)//';'
C**   +----------------------------------------------------------+    **
C**   | assignment,stop,exit,return,call,goto,if()               |    **
C**   +----------------------------------------------------------+    **
      ELSE
        IF(LINN(6:6).EQ.' '.OR.LINN(1:1).NE.' ') THEN
          J=INDEX(LINE(1:LEN),' ! ')
          IF(J.EQ.0) THEN
            LINE(LEN+1:LEN+1)=';'
          ELSE
            LN1=LEN_TRIM(LINE(1:J-1))
            LINE(LN1+1:LN1+1)=';'
          ENDIF
        ENDIF
      ENDIF
      RETURN
      END
************************************************************************
      SUBROUTINE CHANGE(LINE)
C**   ============================================================    **
      CHARACTER LINE*255
C**   ============================================================    **
      LEN=LEN_TRIM(LINE)
      I=7
   10 IF(LINE(I:I).EQ.'.') THEN
        IF(LINE(I:I+3).EQ.'.GE.') THEN
          LINE(I:I+3)=' >= '
        ELSE IF(LINE(I:I+3).EQ.'.LE.') THEN
          LINE(I:I+3)=' <= '
        ELSE IF(LINE(I:I+3).EQ.'.EQ.') THEN
          LINE(I:I+3)=' == '
        ELSE IF(LINE(I:I+3).EQ.'.NE.') THEN
          LINE(I:I+3)=' != '
        ELSE IF(LINE(I:I+3).EQ.'.OR.') THEN
          LINE(I:I+3)=' || '
        ELSE IF(LINE(I:I+3).EQ.'.GT.') THEN
          LINE(I:LEN)=' > '//LINE(I+4:LEN)
          LEN=LEN-1
        ELSE IF(LINE(I:I+3).EQ.'.LT.') THEN
          LINE(I:LEN)=' < '//LINE(I+4:LEN)
          LEN=LEN-1
        ELSE IF(LINE(I:I+4).EQ.'.AND.') THEN
          LINE(I:LEN)=' && '//LINE(I+5:LEN)
          LEN=LEN-1
        ELSE IF(LINE(I:I+4).EQ.'.NOT.') THEN
          LINE(I:LEN)=' ~'//LINE(I+5:LEN)
          LEN=LEN-3
        ENDIF
      ELSE IF(LINE(I:I+2).EQ.'ABS') THEN
        LINE(I:LEN+1)='fabs'//LINE(I+3:LEN)
        LEN=LEN+1
        I=I+1
      ELSE IF(LINE(I:I+3).EQ.'STOP') THEN
        LINE(I:LEN+3)='exit(0)'//LINE(I+4:LEN)
        LEN=LEN+3
      ELSE IF(LINE(I:I+3).EQ.'EXIT') THEN
        LINE(I:LEN+1)='break'//LINE(I+4:LEN)
        LEN=LEN+1
      ELSE IF(LINE(I:I+5).EQ.'RETURN') THEN
        LINE(I:LEN+3)='return(0)'//LINE(I+6:LEN)
        LEN=LEN+3
      ELSE IF(LINE(I:I+3).EQ.'CALL') THEN
        LINE(I:LEN)=LINE(I+5:LEN)
        LEN=LEN-5
      ELSE IF(LINE(I:I+5).EQ.'GO TO ') THEN
        LINE(I:I+5)='goto L'
      ELSE IF(LINE(I:I+6).EQ.') THEN;') THEN  ! if() then
        LINE(I:I+6)=') {'
      ELSE IF(LINE(I:I+5).EQ.') THEN') THEN   ! else if() then
        LINE(I:I+5)=') {'
      ENDIF
      I=I+1
      IF(I.LT.LEN) GO TO 10
      RETURN
      END
************************************************************************
      SUBROUTINE ARRAYS(LINE,AA,LL,NA)
C**   ============================================================    **
      CHARACTER LINE*255,AA(200)*8
      DIMENSION LL(200)
C**   ============================================================    **
      LEN=LEN_TRIM(LINE)
      I=1
   10 IF(LINE(I:I+1).EQ.'/*') RETURN
      IF(LINE(I:I).EQ.'(') THEN
        DO 20 K=1,NA
        IF(LINE(I-LL(K)+1:I).EQ.AA(K)(1:LL(K))) THEN
          J=ICHAR(LINE(I-LL(K):I-LL(K)))
          IF(J.GE.48.AND.J.LE.57) GO TO 20
          IF(J.GE.97.AND.J.LE.122) GO TO 20
          LINE(I:I)='['
          IP=1
          DO 15 J=I+1,LEN
          IF(LINE(J:J).EQ.'(') IP=IP+1
          IF(LINE(J:J).EQ.')') IP=IP-1
          IF(IP.EQ.0) THEN
            LINE(J:J)=']'
            GO TO 30
          ENDIF
   15     CONTINUE
        ENDIF
   20   CONTINUE
      ENDIF
   30 I=I+1
      IF(I.LE.LEN) GO TO 10
      RETURN
      END
************************************************************************
      SUBROUTINE ADTYPE(LINE,LINN)
C**   ============================================================    **
      CHARACTER LINE*255,LINN*255
C**   ============================================================    **
      LEN=LEN_TRIM(LINE)
      I=7
   10 IF(LINE(I:I).EQ.'('.OR.LINE(I:I).EQ.',') THEN
   15   I=I+1
        IF(I.GT.LEN) GO TO 40
        IF(LINE(I:I).EQ.' '.AND.I.LT.LEN) GO TO 15
        IF(LINE(I:I).GE.'I'.AND.LINE(I:I).LE.'N') THEN
          LINE(I:LEN+4)='int '//LINE(I:LEN)
          LEN=LEN+4
        ELSE
          LINE(I:LEN+7)='double '//LINE(I:LEN)
          LEN=LEN+7
        ENDIF
      ENDIF
      I=I+1
      IF(I.LE.LEN) GO TO 10
   40 IF(LINN(6:6).EQ.' ') RETURN
C**
      LEN=LEN_TRIM(LINN)
      I=7
   60 IF(LINN(I:I).EQ.'('.OR.LINN(I:I).EQ.',') THEN
   65   I=I+1
        IF(I.GT.LEN) GO TO 90
        IF(LINN(I:I).EQ.' '.AND.I.LT.LEN) GO TO 65
        IF(LINN(I:I).GE.'I'.AND.LINN(I:I).LE.'N'.OR.
     *     LINN(I:I).GE.'i'.AND.LINN(I:I).LE.'n') THEN
          LINN(I:LEN+4)='int '//LINN(I:LEN)
          LEN=LEN+4
        ELSE
          LINN(I:LEN+7)='double '//LINN(I:LEN)
          LEN=LEN+7
        ENDIF
      ENDIF
      I=I+1
      IF(I.LE.LEN) GO TO 60
   90 RETURN
      END
************************************************************************
      SUBROUTINE DATFLD(DATLIN,NCDAT,ISTAR,IBEGN,ISTOP,FIELD,ITYPE)
C**   ============================================================    **
      CHARACTER*255 DATLIN,FIELD
C**   ============================================================    **
C**   Separate the data fields and identify its data type             **
C**   ------------------------------------------------------------    **
C**   Input : DATLIN(1:NCDAT),NCDAT,ISTAR                             **
C**   Output: IBEGN,ISTOP,ISTAR                                       **
C**           FIELD(1:NCHFI)=DATLIN(IBEGN:ISTOP),ITYPE                **
C**   ------------------------------------------------------------    **
C**   DATLIN: 1 10 1,51 10 X= 0,8,0 Y=0, 0,5  Z=2.5*6                 **
C**   FIELD : 1 10 1 51 10 X= 0 8 0 Y= 0 0 5  Z= 2.5*6                **
C**   ITYPE : 2  2 2  2  2  1 2 2 2  1 2 2 2   1     3                **
C**   ============================================================    **
      ITYPE=2
      NCHFI=0
      IS=ISTAR-1
C**   +----------------------------------------------------------+    **
C**   | Skip leading spaces and ','                              |    **
C**   +----------------------------------------------------------+    **
   10 IS=IS+1
      IBEGN=IS
      IF(IS.GT.NCDAT) GO TO 90
      IF(DATLIN(IS:IS).EQ.' '.OR.DATLIN(IS:IS).EQ.',') GO TO 10
C**   +----------------------------------------------------------+    **
C**   | Save the non-space characters in data FIELD              |    **
C**   +----------------------------------------------------------+    **
   20 NCHFI=NCHFI+1
      FIELD(NCHFI:NCHFI)=DATLIN(IS:IS)
C**   ------------------------------------------------------------    **
      IF(DATLIN(IS:IS).EQ.'=') THEN            ! NAME=
        ITYPE=1
        ISTOP=IS
        ISTAR=IS+1
        RETURN
      ENDIF
C**   ------------------------------------------------------------    **
      IF(DATLIN(IS:IS).EQ.'(') THEN            ! NAME(
        ITYPE=4
        ISTOP=IS
        ISTAR=IS+1
        RETURN
      ENDIF
C**   +----------------------------------------------------------+    **
C**   | Test end-of-field (sapce or ',')                         |    **
C**   +----------------------------------------------------------+    **
      IS=IS+1
      IF(IS.GT.NCDAT) GO TO 90
      IF(DATLIN(IS:IS).NE.' '.AND.DATLIN(IS:IS).NE.',') GO TO 20
   90 ISTOP=IS-1
      ISTAR=IS
      RETURN
      END
************************************************************************
      SUBROUTINE TOLOW(C)
C**   ============================================================    **
      CHARACTER*(*) C
C**   ============================================================    **
C**   Convert C to lower case                                         **
C**   ============================================================    **
      L=LEN(C)
      K=1
      DO WHILE (K.LE.L)
        IF(C(K:K).GT.CHAR(127)) THEN
          K=K+2
        ELSE
          IF(C(K:K).GE.'A'.AND.C(K:K).LE.'Z')
     *                   C(K:K)=CHAR(ICHAR(C(K:K))+32)
          K=K+1
        ENDIF
      ENDDO
      RETURN
      END
************************************************************************
      SUBROUTINE FILEIO(IOFILE,EXT,INAME)
C**   ============================================================    **
      CHARACTER IOFILE*(*),EXT*(*)
C**   ============================================================    **
C**   Input  : EXT,  IOFILE = name.ext  name.  name                   **
C**   Output : INAME,IOFILE = name.ext  name.  name.EXT               **
C**            where   name = IOFILE(1:INAME)                         **
C**   ============================================================    **
      INAME=LEN_TRIM(IOFILE)
      DO 50 K=1,INAME
      IF(IOFILE(K:K).NE.'.') GO TO 50
      INAME=K-1
      RETURN
   50 CONTINUE
      IOFILE=IOFILE(1:INAME)//'.'//EXT
      RETURN
      END
************************************************************************
