#include <stdio.h>
#include <ctype.h>
#include <math.h>
/**********************************************************************/
/*    program for romberg integration                                 */
/*    ============================================================    */
      main() {
/*    ============================================================    */
      double area,aold,xa,xb,eps=0.000001;
      double fa(),fb();
      int    rombrg();
/*    ============================================================    */
      xa=0.0;
      xb=1.0;
      rombrg(xa,xb,fa,&area,&aold,eps);
      printf("\n area =%13.5le \n",area);
/*    ------------------------------------------------------------    */
      xa=-1.0;
      xb= 1.0;
      rombrg(xa,xb,fb,&area,&aold,eps);
      printf("\n area =%13.5le \n",area);
/*    ------------------------------------------------------------    */
      exit(0);
}
/**********************************************************************/
      double fa(double x) {
/*    double fa(x) double x; {                                        */
      double fun;
      fun=1.0/sqrt(1.0+x*x);
      return(fun);
}
/**********************************************************************/
      double fb(double x) {
/*    double fb(x) double x; {                                        */
      double fun;
      fun=x*sin(x);
      return(fun);
}
/**********************************************************************/
