#include <math.h>
/**********************************************************************/
      int rombrg(double xa,double xb,double (*f)()
                ,double *parea,double *paold,double eps) {
/*    int rombrg(xa,xb,f,parea,paold,eps)
      double xa,xb,(*f)(),*parea,*paold,eps; {                        */
/*    ============================================================    */
/*    area = int_xa^xb f(x) dx                                        */
/*    ------------------------------------------------------------    */
      double a[21],h,r,x,an;
      double t[21][21];
      int    i,j,m,n,jj;
/*    ============================================================    */
      h=xb-xa;
      a[1]=0.5*((*f)(xa)+(*f)(xb))*h;
      *parea=a[1];
      t[1][1]=a[1];
      printf("\n %13.5le",t[1][1]);
/*    +----------------------------------------------------------+    */
/*    | compute t^{(1)}_n                                        |    */
/*    +----------------------------------------------------------+    */
      jj=1;
      for(n=2; n<=20; n++) {
        *paold=*parea;
        an=0.0;
        x=xa+h*0.5;
        for(j=1; j<=jj; j++) {
          an=an+(*f)(x);
          x=x+h;
        }
        a[n]=0.5*(a[n-1]+h*an);
        t[n][1]=a[n];
/*      +--------------------------------------------------------+    */
/*      | compute t^{(m)}_n                                      |    */
/*      +--------------------------------------------------------+    */
        r=1.0;
        for(i=n-1; i>=1; i--) {
          r=r*4.;
          a[i]=a[i+1]+(a[i+1]-a[i])/(r-1.);
          t[n][n+1-i]=a[i];
        }
/*                                                                    */
        printf("\n ");
        for(m=1; m<=n; m++) printf("%13.5le",t[n][m]);
/*                                                                    */
        *parea=a[1];
        if(fabs(*paold-*parea) <= eps*fabs(*parea)) return(0);
        h=h*0.5;
        jj=jj+jj;
      }
      return(0);
}
/**********************************************************************/
