#include <math.h>
/**********************************************************************/
      int cdiv(double ar,double ai,double br,double bi
                                  ,double *pcr,double *pci) {
/*    int cdiv(ar,ai,br,bi,pcr,pci) double ar,ai,br,bi,*pcr,*pci; {   */
/*    ============================================================    */
      double s,ars,ais,brs,bis;
/*    ============================================================    */
/*    complex division, (cr,ci) = (ar,ai)/(br,bi)                     */
/*    ============================================================    */
      s = fabs(br) + fabs(bi);
      ars = ar/s;
      ais = ai/s;
      brs = br/s;
      bis = bi/s;
      s    =  brs*brs + bis*bis;
      *pcr = (ars*brs + ais*bis)/s;
      *pci = (ais*brs - ars*bis)/s;
      return(0);
}
/**********************************************************************/
