/**********************************************************************/
      int answer(char msg[],char is) {
/*    ============================================================    */
      char ia[2];
/*    ============================================================    */
/*i   msg = message                                                   */
/*i   is  = default character : 'Y','y','.','N','n','?'               */
/*o   answer = 1        if ia = 'Y','y','.'                           */
/*o   answer = 0        if ia = 'N','n'                               */
/*    ============================================================    */
      ia[0]=is;
  L10:termf(msg,ia,1);
      if(ia[0] != 'Y' && ia[0] != 'y' && ia[0] != '.') goto L20;
      return(1);
  L20:if(ia[0] != 'N' && ia[0] != 'n') goto L10;
      return(0);
}
/**********************************************************************/
      int termf(char msg[],char val[],int n) {
/*    ============================================================    */
      terma(msg,val,n);
      return(0);
}
/**********************************************************************/
      int terma(char msg[],char val[],int n) {
/*    ============================================================    */
      char chx[32];
      int  i,nc;
/*    ============================================================    */
      printf("\n Input  %s /%s/ ?",msg,val);
/*    ------------------------------------------------------------    */
      kyin(chx,&nc);
      if(nc == 0) return(0);
      for(i=0; i<n; i++) val[i]=' '; val[n]='\0';
      for(i=0; i<n; i++) {
        if(chx[i] == '\0') break;
        val[i]=chx[i];
      }
      return(0);
}
/**********************************************************************/
      int termr8(char msg[],double *val) {
/*    ============================================================    */
      char chx[32];
      int  nc;
/*    ============================================================    */
      printf("\n Input  %s /%15.7le/ ?",msg,*val);
/*    ------------------------------------------------------------    */
      kyin(chx,&nc);
      if(nc == 0) return(0);
      sscanf(chx,"%lf",val);
      return(0);
}
/**********************************************************************/
      int termr4(char msg[],float *val) {
/*    ============================================================    */
      char chx[32];
      int  nc;
/*    ============================================================    */
      printf("\n Input  %s /%15.7e/ ?",msg,*val);
/*    ------------------------------------------------------------    */
      kyin(chx,&nc);
      if(nc == 0) return(0);
      sscanf(chx,"%f",val);
      return(0);
}
/**********************************************************************/
      int termi4(char msg[],long *val) {
/*    ============================================================    */
      char chx[32];
      int  nc;
/*    ============================================================    */
      printf("\n Input  %s /%ld/ ?",msg,*val);
/*    ------------------------------------------------------------    */
      kyin(chx,&nc);
      if(nc == 0) return(0);
      sscanf(chx,"%ld",val);
      return(0);
}
/**********************************************************************/
      int termii(char msg[],int *val) {
/*    ============================================================    */
      char chx[32];
      int  nc;
/*    ============================================================    */
      printf("\n Input  %s /%d/ ?",msg,*val);
/*    ------------------------------------------------------------    */
      kyin(chx,&nc);
      if(nc == 0) return(0);
      sscanf(chx,"%d",val);
      return(0);
}
/**********************************************************************/
      int termgt(char msg[],int *igo) {
/*    ============================================================    */
      char isp,chx[32];
      static int ibgn,iend,idon,imax,nc,igg,idet=-1;
/*    ============================================================    */
/*i   msg = ':label:item1:item2:item3:item4::'                        */
/*o   igo = 1:4                                                       */
/*    ============================================================    */
      isp=msg[0];
      idon=idet;
/*    +----------------------------------------------------------+    */
/*    | write label and items                                    |    */
/*    +----------------------------------------------------------+    */
  L10:imax=-1;
      ibgn=1;
/*    +----------------------------------------------------------+    */
/*    | find a label or an item : msg(ibgn:iend)                 |    */
/*    +----------------------------------------------------------+    */
  L15:iend=ibgn;
      while(msg[iend] != isp) iend++;
      if(iend > ibgn) {
        imax=imax+1;
        if(imax == 0) {
          msg[iend]='\0';
          printf("\n  %s",&msg[ibgn]);
          msg[iend]=isp;
        } else {
          if(idon != 0) {
            msg[iend]='\0';
            printf("\n %2d : %s",imax,&msg[ibgn]);
            msg[iend]=isp;
          }
        }
        ibgn=iend+1;
        goto L15;
      }
/*    +----------------------------------------------------------+    */
/*    | get a response                                           |    */
/*    +----------------------------------------------------------+    */
  L50:printf("\n input number between 1 and %d (d:%d) : ",imax,*igo);
      kyin(chx,&nc);
      sscanf(chx,"%d",&igg);
/*    +----------------------------------------------------------+    */
/*    | igg = -1 : not  display items for next call              |    */
/*    | igg = -2 : will display items for next call              |    */
/*    +----------------------------------------------------------+    */
      if(igg < 0) {
        if(igg >= -2) idet=igg+1;
        goto L50;
      }
/*    +----------------------------------------------------------+    */
/*    | test the input value : must between 1 and imax           |    */
/*    +----------------------------------------------------------+    */
      if(nc != 0) *igo=igg;
      if(*igo >= 1 && *igo <= imax) return(0);
      if(idon != 0) goto L50;
      idon=-1;
      goto L10;
}
/**********************************************************************/
      int kyin(char chx[],int *n) {
/*    ============================================================    */
      gets(chx);
      *n=strlen(chx);
      return(0);
}
/**********************************************************************/
