/**********************************************************************/
      int heapb(double a[],double b[],int n) {
/*    int heapb(a,b,n) double a[],b[]; int n; {                       */
/*    ============================================================    */
      double ax,bx; int k,m; int shiftb();
      --a; --b;
/*    ============================================================    */
/*    heap sort : after sorting  a(i) <= a(i+1)                       */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | form heap (a(i),i=k,n) for k=n/2 ... 1                   |    */
/*    +----------------------------------------------------------+    */
      for(k=n/2; k>=1; k--) {
        ax=a[k];
        bx=b[k];
        shiftb(&a[1],&b[1],k,n,ax,bx);
      }
/*    +----------------------------------------------------------+    */
/*    | put max of a(1:m) in the correct position m              |    */
/*    | form heap (a(i),i=1,m-1) for m=n ... 2                   |    */
/*    +----------------------------------------------------------+    */
      for(m=n; m>=2; m--) {
        ax=a[m];
        bx=b[m];
        a[m]=a[1];
        b[m]=b[1];
        shiftb(&a[1],&b[1],1,m-1,ax,bx);
      }
      return(0);
}
/**********************************************************************/
      int shiftb(double a[],double b[],int k,int m,double ax,double bx){
/*    int shiftb(a,b,k,m,ax,bx) double a[],b[],ax,bx; int k,m; {      */
/*    ============================================================    */
      int i,j;
      --a; --b;
/*    ============================================================    */
/*    given ax and heap a(k+1:m)  where  k  <=  m                     */
/*    shift ax down to form new heap a(k:m)                           */
/*    a: a(i) >= a(2*i)  &&  a(i) >= a(2*i+1)                         */
/*    ============================================================    */
      i=k;
  L60:j=i+i;
      if(j <= m) {
        if(j < m) {
          if(a[j+1] > a[j]) j=j+1;
        }
        if(a[j] > ax) {
/*        +------------------------------------------------------+    */
/*        | shift ax down to position j                          |    */
/*        +------------------------------------------------------+    */
          a[i]=a[j];
          b[i]=b[j];
          i=j;
          goto L60;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | no more shift down : i is the correct position for ax    |    */
/*    +----------------------------------------------------------+    */
      a[i]=ax;
      b[i]=bx;
      return(0);
}
/**********************************************************************/
