/**********************************************************************/
      int heap(double a[],int n) {
/*    int heap(a,n) double a[]; int n; {                              */
/*    ============================================================    */
      double ax; int k,m; int shift();
      --a;
/*    ============================================================    */
/*    heap sort : after sorting  a(i) <= a(i+1)                       */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | form heap (a(i),i=k,n) for k=n/2 ... 1                   |    */
/*    +----------------------------------------------------------+    */
      for(k=n/2; k>=1; k--) {
        ax=a[k];
        shift(&a[1],k,n,ax);
      }
/*    +----------------------------------------------------------+    */
/*    | put max of a(1:m) in the correct position m              |    */
/*    | form heap (a(i),i=1,m-1) for m=n ... 2                   |    */
/*    +----------------------------------------------------------+    */
      for(m=n; m>=2; m--) {
        ax=a[m];
        a[m]=a[1];
        shift(&a[1],1,m-1,ax);
      }
      return(0);
}
/**********************************************************************/
      int shift(double a[],int k,int m,double ax) {
/*    int shift(a,k,m,ax) double a[],ax; int k,m; {                   */
/*    ============================================================    */
      int i,j;
      --a;
/*    ============================================================    */
/*    given ax and heap a(k+1:m)  where  k  <=  m                     */
/*    shift ax down to form new heap a(k:m)                           */
/*    a: a(i) >= a(2*i)  &&  a(i) >= a(2*i+1)                         */
/*    ============================================================    */
      i=k;
  L60:j=i+i;
      if(j <= m) {
        if(j < m) {
          if(a[j+1] > a[j]) j=j+1;
        }
        if(a[j] > ax) {
/*        +------------------------------------------------------+    */
/*        | shift ax down to position j                          |    */
/*        +------------------------------------------------------+    */
          a[i]=a[j];
          i=j;
          goto L60;
        }
      }
/*    +----------------------------------------------------------+    */
/*    | no more shift down : i is the correct position for ax    |    */
/*    +----------------------------------------------------------+    */
      a[i]=ax;
      return(0);
}
/**********************************************************************/
