/**********************************************************************/
      int quickl(double a[],int l[],int n) {
/*    int quickl(a,l,n) double a[]; int l[],n; {                      */
/*    ============================================================    */
      int lx,lt,i,j,k,m,nn,ix,il[21],iu[21];
      --a; --l;
/*    ============================================================    */
/*    quick sort : after sorting  a(l(i)) <= a(l(i+1))                */
/*    il(nn),iu(nn) permit sorting up to n=2**(nn+1)-1                */
/*    ============================================================    */
      for(i=1; i<=n; i++) {
        l[i]=i;
      }
/*    ------------------------------------------------------------    */
      i=1;
      m=n;
      nn=1;
/*    ------------------------------------------------------------    */
  L10:if(i >= m) goto L70;
/*    +----------------------------------------------------------+    */
/*    | sorting a(l(i)),a(l(ix)),a(l(m))                         |    */
/*    | and get a(lx)=mid(a(l(i)),a(l(ix)),a(l(m)))              |    */
/*    +----------------------------------------------------------+    */
      ix=(i+m)/2;
      lx=l[ix];
      if(a[l[i]] > a[lx]) {
        l[ix]=l[i];
        l[i]=lx;
        lx=l[ix];
      }
      if(a[lx] > a[l[m]]) {
        l[ix]=l[m];
        l[m]=lx;
        lx=l[ix];
        if(a[l[i]] > a[lx]) {
          l[ix]=l[i];
          l[i]=lx;
          lx=l[ix];
        }
      }
/*    ============================================================    */
/*    subroutine partition(a,l,i,m,j,k,lx)                            */
/*    ============================================================    */
/*    sorting a(l(i:m)) by partition into a(l(i:k)) and a(l(j:m))     */
/*    ============================================================    */
/*    such that  i <= k < j <= m  provided i < m                      */
/*    a(l(x)) <= a(lx)  for  i <= x <= k                              */
/*    a(l(x))  = a(lx)  for  k <  x <  j                              */
/*    a(l(x)) >= a(lx)  for  j <= x <= m                              */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | test right part for a(l(k))>a(lx) & left a(l(j))<a(lx)   |    */
/*    +----------------------------------------------------------+    */
      j=i;
      k=m;
  L40:k=k-1;
      if(a[l[k]] > a[lx]) goto L40;
  L50:j=j+1;
      if(a[lx] > a[l[j]]) goto L50;
/*    ------------------------------------------------------------    */
      if(j <= k) {
        lt=l[j];
        l[j]=l[k];
        l[k]=lt;
        goto L40;
      }
/*    +----------------------------------------------------------+    */
/*    | end of partitioning : find longer partition to save      |    */
/*    +----------------------------------------------------------+    */
      if(k-i > m-j) {
/*      +--------------------------------------------------------+    */
/*      | save  left partition a(l(i:k)) then sort a(l(j:m))     |    */
/*      +--------------------------------------------------------+    */
        il[nn]=i;
        iu[nn]=k;
        nn=nn+1;
        i=j;
      } else {
/*      +--------------------------------------------------------+    */
/*      | save right partition a(l(j:m)) then sort a(l(i:k))     |    */
/*      +--------------------------------------------------------+    */
        il[nn]=j;
        iu[nn]=m;
        nn=nn+1;
        m=k;
      }
      goto L80;
/*    +----------------------------------------------------------+    */
/*    | get a saved partition a(l(i:m)) for sorting              |    */
/*    +----------------------------------------------------------+    */
  L70:nn=nn-1;
      if(nn == 0) return(0);
      i=il[nn];
      m=iu[nn];
/*    +----------------------------------------------------------+    */
/*    | use quick sort for long key array                        |    */
/*    +----------------------------------------------------------+    */
  L80:if(m-i >= 11 || i == 1) goto L10;
/*    +----------------------------------------------------------+    */
/*    | use shaker sort for short key array                      |    */
/*    +----------------------------------------------------------+    */
  L90:i=i+1;
      if(i > m) goto L70;
      if(a[l[i-1]] <= a[l[i]]) goto L90;
      k=i;
      lx=l[k];
  L95:l[k]=l[k-1];
      k=k-1;
      if(a[l[k-1]] > a[lx]) goto L95;
/*    ------------------------------------------------------------    */
      l[k]=lx;
      goto L90;
}
/**********************************************************************/
