/**********************************************************************/
      int shakeg(int n) {
/*    int shakeg(n) int n; {                                          */
/*    ============================================================    */
      int i,k;
      int icmpij(),icmpix(),moveij(),moveix(),movexj(),initil();
/*    dimension a(n) | a(n),l(n)                                      */
/*    ============================================================    */
/*    shaker ascending sort (for decending : change  <=  to  >= )     */
/*    =================< key sorting >==+===< index sorting >=====    */
/*    after sorting a : a(i) <= a(i+1)  |  a(l(i)) <= a(l(i+1))       */
/*                  d : a(i) >= a(i+1)  |  a(l(i)) >= a(l(i+1))       */
/*    ----------------------------------+-------------------------    */
/*    icmpij(i,j) = a : a(i) <= a(j)    |  a(l(i)) <= a(l(j))         */
/*    icmpix(i)   = a : a(i) <=  ax     |  a(l(i)) <=  a(lx)          */
/*    icmpxj(j)   = a :  ax  <= a(j)    |   a(lx)  <= a(l(j))         */
/*    ----------------------------------+-------------------------    */
/*    moveij(i,j) :      a(i)=a(j)      |      l(i)=l(j)              */
/*    moveix(i)   :      a(i)=ax        |      l(i)=lx                */
/*    movexj(i)   :      ax=a(j)        |      lx=l(j)                */
/*    ----------------------------------+-------------------------    */
/*    swapij(i,j) :   at=a(i)           |   lt=l(i)                   */
/*                :      a(i)=a(j)      |      l(i)=l(j)              */
/*                :           a(j)=at   |           l(j)=lt           */
/*    ----------------------------------+-------------------------    */
/*    rotxij(i,j) : (ax=a(i)) a(i)=a(j) | (lx=l(i)) l(i)=l(j)         */
/*                :  a(j)=ax & ax=a(i)  |  l(j)=lx & lx=l(i)          */
/*    ============================================================    */
/*    initil(n)   : set l(i)=i for i=1,n for index sorting            */
/*    ============================================================    */
      initil(n);
/*    ------------------------------------------------------------    */
      for(i=2; i<=n; i++) {
        if(icmpij(i-1,i)) continue;
        k=i;
        movexj(k);
        do {
          moveij(k,k-1);
          k=k-1;
          if(k <= 1) break;
        } while(!icmpix(k-1));
       moveix(k);
      }
      return(0);
}
/**********************************************************************/
