#include <stdio.h>
#include <ctype.h>
int freeii(int    *, FILE *);
/**********************************************************************/
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE *fopen(),*fp_r;
      int nelm,node,nedg,npnt,n1,n2,n3,n4,n5,n6,ia[2000],ndim=2000;
      int graphs(),genrcm(),femrcm(),graphi(),grapho();
/*    ============================================================    */
      if(argc<2) {printf("Usage : trcm infile > outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
  L10:freeii(&nelm,fp_r); freeii(&node,fp_r); if(nelm == 0) exit(0);
      n1=0;
      n2=n1+nelm+1;
      graphi(&ia[n1],&ia[n2],nelm,&npnt,fp_r);
/*    ------------------------------------------------------------    */
      n3=n2+npnt;
      n4=n3+node;
      n5=n4+node+1;
      n6=n5+npnt;
      if(n6 > ndim) exit(1);
      femrcm(&ia[n1],&ia[n2],&ia[n3],&ia[n4],&ia[n5],nelm,node);
      grapho(&ia[n3],&ia[n4],&ia[n5],node,0);
/*    ------------------------------------------------------------    */
      graphs(&ia[n1],&ia[n2],&ia[n3],&ia[n4],&ia[n5],nelm,node,&nedg);
      n6=n5+nedg;
      if(n6 > ndim) exit(1);
      genrcm(node,&ia[n4],&ia[n5],&ia[n3]);
      grapho(&ia[n3],&ia[n4],&ia[n5],node,1);
      goto L10;
}
/**********************************************************************/
      int graphi(int joep[],int joes[],int nelm,int *npnt,FILE *fp_r) {
/*    int graphi(joep,joes,nelm,npnt,fp_r)
      int joep[],joes[],nelm,*npnt; FILE *fp_r; {                     */
/*    ============================================================    */
      int j,ie;
      --joep; --joes;
/*    ============================================================    */
      j=0;
      joep[1]=1;
      for(ie=1; ie<=nelm; ie++) {
        free00(fp_r);
        do {
          freeii(&joes[++j],NULL);
        } while(joes[j] > 0);
        joep[ie+1]=j;
        j--;
      }
      *npnt=j;
/*    ------------------------------------------------------------    */
      printf("\n\n joep/joes:");
      printl(&joep[1],nelm+1);
      printl(&joes[1],*npnt);
      return(0);
}
/**********************************************************************/
      int grapho(int lvsn[],int eojp[],int eojs[],int node,int m) {
/*    int grapho(lvsn,eojp,eojs,node,m)
      int lvsn[],eojp[],eojs[],node,m; {                              */
/*    ============================================================    */
      --lvsn; --eojp; --eojs;
/*    ============================================================    */
      if(m == 0) printf("\n\n lvsn/eojp/eojs:");
      if(m == 1) printf("\n\n lvsn/xadj/adjn:");
      printl(&lvsn[1],node);
      printl(&eojp[1],node+1);
      printl(&eojs[1],eojp[node+1]-1);
      return(0);
}
/**********************************************************************/
      int printl(int l[],int n) {
/*    int printl(l,n) int l[],int n; {                                */
/*    ============================================================    */
      int i;
/*    ============================================================    */
      for(i=0; i<n; i++) {
        if(i%10 == 0) printf("\n"); printf("%8d",l[i]);
      }
      return(0);
}
/**********************************************************************/
