#include <math.h>
struct {int n; double x[99],f[99],d[99],c[100];} ran000;
/**********************************************************************/
      double gauss(double amean,double sigma) {
/*    double gauss(amean,sigma) double amean,sigma; {                 */
/*    ============================================================    */
      double dx,snp1,fun; int i,n,nh; double ranfun(),denfun();
      static long ix=-1;
/*    ============================================================    */
/*    use mixed method (invert method & reject-select method)         */
/*    to find the normal distributed number                           */
/*    ============================================================    */
      if(ix < 0) {
         ix=11111;
/*       +-------------------------------------------------------+    */
/*       | set n,x(1:n),f(1:n),d(2:n),c(1:n+1)                   |    */
/*       | for unit std. div. zero mean normal dist.             |    */
/*       +-------------------------------------------------------+    */
         dx = 0.25;
         n  = 49;
/*       ---------------------------------------------------------    */
         nh = (n+1)/2;
         n = nh*2-1;    ran000.n = n;
         for(i=0; i<nh; i++) {
           ran000.x[i]     =  (i-nh+1)*dx;
           ran000.c[i]     =  denfun(ran000.x[i]);
           ran000.x[n-i-1] = -ran000.x[i];
           ran000.c[n-i  ] =  ran000.c[i];
         }
         for(i=1; i<nh; i++) {
           ran000.d[i]   =  ran000.c[i-1]/ran000.c[i];
           ran000.d[n-i] =  ran000.d[i];
         }
/*       +-------------------------------------------------------+    */
/*       | neglect the infinite sections                         |    */
/*       +-------------------------------------------------------+    */
         ran000.c[1]   = 0.0;
         ran000.c[n+1] = 0.0;
/*       +-------------------------------------------------------+    */
/*       | calculate referential f(1:n) from x(1:n) and c(1:n+1) |    */
/*       | follows are general procedure (for n>0)               |    */
/*       +-------------------------------------------------------+    */
         ran000.f[0]=ran000.c[0];
         for(i=1; i<n; i++) {
           ran000.f[i]=ran000.f[i-1]
                      +(ran000.x[i]-ran000.x[i-1])*ran000.c[i];
         }
         snp1=ran000.f[n-1]+ran000.c[n];
         for(i=0; i<n; i++) {
           ran000.f[i]=ran000.f[i]/snp1;
         }
/*       next st. is to prevent choose from 1st section               */
         if (ran000.f[0] == 0.0) ran000.f[0]=-0.00001;
      }
/*    ------------------------------------------------------------    */
      fun = amean + sigma * ranfun(&ix);
      return(fun);
}
/**********************************************************************/
      double denfun(double x) {
/*    double denfun(x) double x; {                                    */
/*    ============================================================    */
      double fun; static double rsqr2p=0.3989422804014327;
/*    ============================================================    */
/*    denfun = density function of a random number x                  */
/*    for unit std. div. zero mean normal dist.                       */
/*    ============================================================    */
      fun = rsqr2p * exp(-0.5*x*x);
      return(fun);
}
/**********************************************************************/
      int finvl(double dis,double *var,double *den) {
/*    int finvl(dis,var,den) double dis,*var,*den; {                  */
/*    ============================================================    */
      return(0);
}
/**********************************************************************/
      int finvr(double dis,double *var,double *den) {
/*    int finvr(dis,var,den) double dis,*var,*den; {                  */
/*    ============================================================    */
      return(0);
}
/**********************************************************************/
