#include <math.h>
/**********************************************************************/
      int fminim(double *pxm,double *pfm,double (*f)(),double xini
                ,double dx,double eps,int itmax,double dmag) {
/*    int fminim(pxm,pfm,f,xini,dx,eps,itmax,dmag)
      double *pxm,*pfm,(*f)(),xini,dx,eps,dmag; int itmax; {          */
/*    ============================================================    */
      double xx,xo,xn,xm,fx,fo,fm,errx,errd; double xmin();
      static double buffer[25]; /* clear with static */
      int    istep,nstp,ivy,i;
/*    ============================================================    */
/*    find minimier of f(xm) from the initial guess xini              */
/*    ============================================================    */
                      nstp=itmax;
      if(nstp == 0)   nstp=12;
                      errx=eps;
      if(errx == 0.0) errx=0.000001;
                      errd=sqrt(errx);
      if(xini != 0.0) errx=errx*fabs(xini);
      if(dmag != 0.0) errd=errd*dmag;
/*    ------------------------------------------------------------    */
      xx=1.0e30;
      fx=1.0e30;
      xn=xini;
      xm=xx;
      fm=fx;
      for(istep=1; istep<=nstp; istep++) {
        xo=xx;
        fo=fx;
        xx=xn;
        fx=f(xx);
        if(fx < fm) {
          fm=fx;
          xm=xx;
        }
        xn=xmin(xx,fx,dx,istep,&ivy,buffer);
        if(istep == 2 && dmag == 0.0) errd=errd*fabs((fx-fo)/(xx-xo));
        printf("\n buf(*)");
        for(i=0; i<25; i++) {    if(i >= 14 && buffer[20] == 0) break;
          if(i%5 == 0) printf("\n");
          printf("%15.6le",buffer[i]);
        }
        if(istep >= 4 || ivy != 0) {
          if(fabs(xx-xo) <= errx) break;
          if(fabs(fx-fo) <= errd*fabs(xx-xo)) break;
        }
      }
      *pxm=xm; *pfm=fm; return(0);
}
/**********************************************************************/
