************************************************************************
      SUBROUTINE FMINIM(XM,FM,F,XINI,DX,EPS,ITMAX,DMAG)
C**   ============================================================    **
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION BUFFER(25)
C**   ============================================================    **
C**   Find minimier of F(XM) from the initial guess XINI              **
C**   ============================================================    **
                      NSTP=ITMAX
      IF(NSTP.EQ.0)   NSTP=12
                      ERRX=EPS
      IF(ERRX.EQ.0.0) ERRX=0.000001
                      ERRD=SQRT(ERRX)
      IF(XINI.NE.0.0) ERRX=ERRX*ABS(XINI)
      IF(DMAG.NE.0.0) ERRD=ERRD*DMAG
C**   ------------------------------------------------------------    **
      XX=1.0D30
      FX=1.0D30
      XN=XINI
      XM=XX
      FM=FX
      DO 10 ISTEP=1,NSTP
        XO=XX
        FO=FX
        XX=XN
        FX=F(XX)
        IF(FX.LT.FM) THEN
          FM=FX
          XM=XX
        ENDIF
        XN=XMIN(XX,FX,DX,ISTEP,IVY,BUFFER)
        IF(ISTEP.EQ.2.AND.DMAG.EQ.0.0) ERRD=ERRD*ABS((FX-FO)/(XX-XO))
        WRITE(*,'('' BUF(25)''/(1X,1P5E15.8))') BUFFER
        IF(ISTEP.GE.4.OR.IVY.NE.0) THEN
          IF(ABS(XX-XO).LE.ERRX) RETURN
          IF(ABS(FX-FO).LE.ERRD*ABS(XX-XO)) RETURN
        ENDIF
   10 CONTINUE
      RETURN
      END
************************************************************************
