#include <stdio.h>
#include <ctype.h>
#include <math.h>
int freeii(int    *, FILE *);
int freer8(double *, FILE *);
/**********************************************************************/
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE   *fopen(),*fp_r,*fp_w;
static double a[5000],ppen[10],beztyp[5],epsk[6]; int maxk[4],ndim=5000;
      int    n1,n2,n3,n4,n5,n6,n7,n8,n9,na,nb,nc,nd,ne,nf,ng,nh;
      int    i,n,nn,ns,nx,maxn,maxa; int slinsh(),inpxpp();
/*    ============================================================    */
/*    sequential linear search the penalty function                   */
/*    ============================================================    */
      if(argc<3) {printf("Usage : slslag infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ============================================================    */
      freeii(&nx,fp_r); freeii(&ns,fp_r); freeii(&ne,fp_r);
      if(nx == 0) exit(0);
      for(i=0; i<4; i++) freeii(&maxk[i],fp_r);
      for(i=0; i<6; i++) freer8(&epsk[i],fp_r);
/*    ------------------------------------------------------------    */
      n=nx+ns+ns+ne;
      if(maxk[3] <= 0) n=nx;
      nn=n*(n+1)/2;
      maxn=3*n;
      n1=0;
      n2=n1+n;                  /* xold(n) */
      n3=n2+n;                  /* xnew(n) */
      n4=n3+n;                  /* sn(n) */
      n5=n4+n;                  /* sc(n) */
      n6=n5+n;                  /* gc(n) */
      n7=n6+n;                  /* gp(n) */
      n8=n7+nx;                 /* pfac(nx)          : penalty  */
      if(maxk[3] > 0)
      n8=n7+nx+n+n;             /* pfac(nx+n+n)      : Lagrange */
      n9=n8+2*(ns+ne);          /* c(2*(ns+ne))      : Lagrange */
      if(maxk[2] > 0)
      n9=n8+(4+nx)*(ns+ne);     /* c((4+nx)*(ns+ne)) : penalty  */
      na=n9+n;                  /* xo(n) */
      nb=na+n;                  /* xc(n) */
      nc=nb+n;                  /* d(n) */
      nd=nc+maxn;               /* l(n),l(maxn) */
      nf=nd+nn;                 /* h(n,n) */
      ng=nf+n;                  /* s(n) */
      nh=ng+n;                  /* y(n) */
      maxa=ndim-nh;             /* t(maxa) */
      if(maxa < nn+n) {printf("\n dimension too small !"); exit(1);}
/*    +----------------------------------------------------------+    */
/*    | input xold(nx),pfac(nx),ppen(10),beztyp(5)               |    */
/*    +----------------------------------------------------------+    */
      inpxpp(&a[n1],&a[n7],ppen,beztyp,nx,fp_r);
/*    +----------------------------------------------------------+    */
/*    | call slinsh to perform sequential linear search          |    */
/*    +----------------------------------------------------------+    */
      slinsh(nx,ns,ne,n,&a[n1],&a[n2],&a[n3],&a[n4],&a[n5],&a[n6],&a[n7]
         ,&a[n8],&a[n9],&a[na],&a[nb],&a[nc],&a[nd],&a[nf],&a[ng],&a[nh]
         ,maxa,maxn,ppen,beztyp,maxk,epsk);
      exit(0);
}
/**********************************************************************/
      int inpxpp(double xold[],double pfac[],double ppen[]
                              ,double beztyp[],int nx,FILE *fp_r) {
/*    int inpxpp(xold,pfac,ppen,beztyp,nx,fp_r)
      double xold[],pfac[],ppen[],beztyp[]; int nx; FILE *fp_r; {     */
/*    ============================================================    */
      double ppend[10]={1.0,1.0,1.0,0.001,1.0,1.0,2.0,2.0,1.0,0.05};
      int    i;
/*    ============================================================    */
/*    read initial values xold(nx), and scalar factor of xold(nx)     */
/*    read ppen(10)  = r(3),t,c1,c2,rat(4)                            */
/*    read beztyp(5) = nb,v,dir1,dir2,vm                              */
/*    ============================================================    */
      for(i=0; i<nx; i++) freer8(&xold[i],fp_r);
      for(i=0; i<nx; i++) freer8(&pfac[i],fp_r);
      for(i=0; i<10; i++) freer8(&ppen[i],fp_r);
      for(i=0; i<5;  i++) freer8(&beztyp[i],fp_r);
/*    +----------------------------------------------------------+    */
/*    | check initial setting                                    |    */
/*    +----------------------------------------------------------+    */
      for(i=0; i<nx; i++) {
        if(pfac[i] == 0.0) pfac[i]=1.0;
      }
      for(i=0; i<10; i++) {
        if(ppen[i] == 0.0) ppen[i]=ppend[i];
      }
      if(beztyp[1] <= 0 || beztyp[1] > 1) beztyp[1]=1;/* 0 <  v  <= 1 */
      if(beztyp[4] < 0) beztyp[4]=0.0;                /* 0 <= vm <= 1 */
      if(beztyp[4] > 1) beztyp[4]=1.0;                /* 0 <= vm <= 1 */
      return(0);
}
/**********************************************************************/
      int slinsh(int nx,int ns,int ne,int n,double xold[],double xnew[]
                ,double sn[],double sc[],double gc[],double gp[]
                ,double pfac[],double c[],double xo[],double xc[]
                ,double d[],int l[],double h[],double s[]
                ,double y[],double t[],int maxa,int maxn,double ppen[]
                ,double beztyp[],int maxk[],double epsk[]) {
/*    int slinsh(nx,ns,ne,n,xold,xnew,sn,sc,gc,gp,pfac,c,xo,xc
                ,d,l,h,s,y,t,maxa,maxn,ppen,beztyp,maxk,epsk)
      double xold[],xnew[],sn[],sc[],gc[],gp[],pfac[],c[],xo[],xc[];
      double d[],h[],s[],y[],t[],ppen[],beztyp[],epsk[];
      int    nx,ns,ne,n,l[],maxa,maxn,maxk[]; {                       */
/*    ============================================================    */
      double w,wold,xx,f,ff,gg,efmax,egmax,exmax,epsmah,tmp;
      int    i,ic,im,it,nt,k,idir;
      int    fdhess(),gfnlag(),gfnpen(),maheps();
      int    linsch(),sncdir(),outxwg(),fff();
/*    ============================================================    */
/*    find minimizer xnew(n) of gf*(xnew(n)) by linear search         */
/*    ------------------------------------------------------------    */
/*i   nx        = number of original variables                        */
/*i   ns        = number of constraints gj(xp(nx)) <= 0               */
/*i   ne        = number of constraints hi(xp(nx))  = 0               */
/*i   xold(n)   = xold = xp(nx)[,s(ns),ls(ns),le(ne)]                 */
/*o   xnew(n)   = xnew = xp(nx)[,s(ns),ls(ns),le(ne)]                 */
/*w   sn(n)     = xn - xold = newton direction                        */
/*w   sc(n)     = xc - xold = cauchy direction                        */
/*w   gc,gp(n)  = for gradients                                       */
/*i   pfac(nx)  = scalar factor of xp(nx)                             */
/*i   beztyp(2) = nb,v for type of bezier curve (see sub. spt)        */
/*i         (3) = 0:4 direction index of linear search by penalty     */
/*i         (4) = 0:4 direction index of linear search by lagrange    */
/*i         (5) = bfgs/(dfp+bfgs) : proportion of update methods      */
/*w   xo(n)     = initial x(n) of unconstrained opt.                  */
/*w   xc(n)     = initial x(n) of linear search                       */
/*w   d(n)      = added diagonal elements                             */
/*w   l(n)      = location index of hessian matrix                    */
/*w   h(n,n)    = hessian matrix                                      */
/*w   s(n)      = xp(n)-xc(n)                                         */
/*w   y(n)      = gp(n)-gc(n)                                         */
/*w   t(maxa)   = inv.h & sol.                                        */
/*i   maxk(1)   = maximum iteration number of unconstrained opt.      */
/*i   maxk(2)   = maximum iteration number of linear search           */
/*i   maxk(3)   = maximum iteration number by penalty function        */
/*i   maxk(4)   = maximum iteration number by lagrange multiplier     */
/*s   spt       = sub. to get xnew from xx                            */
/*s   gfnpen    = sub. to get general obj. function of xnew(n)        */
/*s   fff       = sub. to compute f(xp(nx)),gj(xp(nx)),hi(xp(nx))     */
/*    ::for penalty function                                          */
/*i   n         = nx                                                  */
/*i   xold(n)   = xp(nx)                                              */
/*w   c(2*nc)   = gj(xp(nx)),hi(xp(nx)),dysj/dgj,dyei/dhi             */
/*i   ppen(10)  = r(3),t,c1,c2,rat(4)                                 */
/*    ::for lagrange multiplier                                       */
/*i   n         = nx+ns+ns+ne                                         */
/*i   xold(n)   = xp(nx),s(ns),ls(ns),le(ne)                          */
/*w   pfac(nx+1  :nx+n  ) = newton point xn(n)     : for gfmlag       */
/*w   pfac(nx+n+1:nx+n+n) = modified diagonal d(n) : for gfmlag       */
/*w   c(nc)     = gj(xp(nx)),hi(xp(nx))                               */
/*    ============================================================    */
/*    +----------------------------------------------------------+    */
/*    | constrained opt. by sequential unconstrained opt.        |    */
/*    | save initial value for convergence test                  |    */
/*    +----------------------------------------------------------+    */
      for(ic=0; ic<maxk[0]; ic++) {
        for(i=0; i<n; i++) {
          xo[i]=xold[i];
        }
/*      +--------------------------------------------------------+    */
/*      | im = 2 : using penalty function method                 |    */
/*      | im = 3 : using lagrange multiplier method              |    */
/*      +--------------------------------------------------------+    */
        for(im=2; im<4; im++) {
          if(maxk[im] <= 0) continue;
          if(im == 2) nt=nx;
          if(im == 3) nt=nx+ns+ns+ne;
          idir=beztyp[im];
          if(idir <= 2) beztyp[0]=0;  /* nb=0 sc for univariate,fr,pr */
          if(idir == 3) beztyp[0]=1;  /* nb=1 sn for quasi-newton     */
          if(idir >= 4) beztyp[0]=2;  /* nb=2 sc,sn for bezier curve  */
/*        +------------------------------------------------------+    */
/*        | compute hessian matrix h(nt,nt) at xold(nx)          |    */
/*        +------------------------------------------------------+    */
          if(idir >= 3) {         /* for idir=3,4 */
            l[0]=0;
            for(i=1; i<nt; i++) {
              l[i]=l[i-1]+i;
            }
            maheps(&epsmah);
            fdhess(nx,ns,ne,nt,xold,pfac,ppen,c,gp,d,epsmah,l,h);
          }
          for(it=1; it<=maxk[im]; it++) {
/*          +----------------------------------------------------+    */
/*          | find sc & sn directions                            |    */
/*          +----------------------------------------------------+    */
            sncdir(nx,ns,ne,nt,xc,xold,sn,sc,gc,gp,pfac,ppen,beztyp
                            ,c,&wold,d,l,h,s,y,t,maxa,maxn,it,idir);
            printv(sc,nt,"sc");
            if(idir > 2 ) printv(sn,nt,"sn");
/*          +----------------------------------------------------+    */
/*          | linear search along bezier curve (xold,sc,sn)(nx)  |    */
/*          +----------------------------------------------------+    */
            if(im == 2) {
              if(idir <= 0) gfnpen(nx,ns,ne,xold,pfac,ppen,c,&wold);
              linsch(nx,ns,ne,nt,xold,xnew,sn,sc,pfac
                              ,ppen,c,beztyp,gfnpen);
              gfnpen(nx,ns,ne,xnew,pfac,ppen,c,&w);
            } else {
              for(i=0; i<nt; i++) {
                pfac[i+nx]=xold[i]+sn[i];
                pfac[i+nx+nt]=d[i];
              }
              if(idir <= 0) gfnlag(nx,ns,ne,xold,pfac,ppen,c,&wold);
              linsch(nx,ns,ne,nt,xold,xnew,sn,sc,pfac
                              ,ppen,c,beztyp,gfnlag);
              gfnlag(nx,ns,ne,xnew,pfac,ppen,c,&w);
            }
/*          +----------------------------------------------------+    */
/*          | output intermediate results                        |    */
/*          +----------------------------------------------------+    */
            outxwg(it,nx,ns,ne,xnew,w,c);
/*          +----------------------------------------------------+    */
/*          | test convergence                                   |    */
/*          +----------------------------------------------------+    */
            exmax=0.0;
            egmax=0.0;
            if(idir <= 0) egmax=1.0;
            ff=fabs(w); if(ff < 1.0e-6) ff=1.0e-6;
            for(i=0; i<nt; i++) {
              xx=fabs(xold[i]); if(xx < 1.0) xx=1.0;
              gg=fabs(c[i]);    if(gg < 1.0) gg=1.0;
              if((tmp=fabs(gp[i])*xx/gg)        > egmax) egmax=tmp;
              if((tmp=fabs(xnew[i]-xold[i])/xx) > exmax) exmax=tmp;
              xc[i]=xold[i];
              xold[i]=xnew[i];
            }
            efmax=fabs(wold-w)/ff;
            printf("\n egmax,efmax,exmax,epsk[4],epsk[5],epsk[%d]:",im);
            printf("\n %12.3le%12.3le%12.3le%12.3le%12.3le%12.3le"
                      ,egmax,efmax,exmax,epsk[4],epsk[5],epsk[im]);
            if(egmax <= epsk[4])  goto L310;
            if(efmax <= epsk[5])  goto L310;
            if(exmax <= epsk[im]) goto L310;
          }
        }
/*      +--------------------------------------------------------+    */
/*      | test convergence of constrained optimization           |    */
/*      +--------------------------------------------------------+    */
 L310:  fff(nx,ns,ne,xold,&f,c);
        outxwg(it,nx,ns,ne,xold,f,c);
        exmax=0.0;
        for(i=0; i<n; i++) {
          xx=fabs(xold[i]); if(xx < 1.0) xx=1.0;
          if((tmp=fabs(xo[i]-xold[i])/xx) > exmax) exmax=tmp;
        }
        if(exmax <= epsk[0]) break;
/*      +--------------------------------------------------------+    */
/*      | modify penalty coefficients r(3) and t                 |    */
/*      +--------------------------------------------------------+    */
        for(k=0; k<4; k++) {
          ppen[k]=ppen[k]*ppen[k+6];
        }
      }
/*    +----------------------------------------------------------+    */
/*    | return(0)                                                |    */
/*    +----------------------------------------------------------+    */
      return(0);
}
/**********************************************************************/
      int outxwg(int it,int nx,int ns,int ne
                ,double xx[],double wo,double gwo[]) {
/*    int outxwg(it,nx,ns,ne,xx,wo,gwo)
      double xx[],wo,gwo[]; int it,nx,ns,ne; {                        */
/*    ============================================================    */
      int printv();
/*    ============================================================    */
/*    output final results                                            */
/*    ============================================================    */
      printf("\n ========= \n after %d linear search:",it);
      printf("\n the objective function is %12.4le",wo);
      printv(xx,nx,"values of variables");
      printv(gwo,ns+ne,"values of constraint");
      return(0);
}
/**********************************************************************/
      int sncdir(int nx,int ns,int ne,int n,double xc[],double xold[]
         ,double sn[],double sc[],double gc[],double gp[],double pfac[]
         ,double ppen[],double beztyp[],double c[],double *fp,double d[]
         ,int l[],double h[],double s[],double y[],double t[]
         ,int maxa,int maxn,int it,int idir) {
/*    int sncdir(nx,ns,ne,n,xc,xold,sn,sc,gc,gp,pfac
         ,ppen,beztyp,c,fp,d,l,h,s,y,t,maxa,maxn,it,idir)
      double xc[],xold[],sn[],sc[],gc[],gp[],pfac[];
      double ppen[],beztyp[],c[],*fp,d[],l[],h[],s[],y[],t[];
      int    nx,ns,ne,n,l[],maxa,maxn,it,idir; {                      */
/*    ============================================================    */
/*    dimension xc(n),xold(n),sn(n),sc(n),gc(n),gp(n),pfac(nx),ppen(6)*/
/*    dimension beztyp(4),c(1),d(n),l(n),h(maxa),s(n),y(n),t(maxa)    */
      double angrad,vm,epsmah;  int i,k,istep;
      int    bfgslg(),fr(),pr(),fdgrad(),findsn(),findsc(),maheps();
/*    ============================================================    */
/*    find newton & cauchy direction sn(n) & sc(n)                    */
/*    ------------------------------------------------------------    */
/*    input   : nx,ns,ne,n,maxa,maxn,it,idir                          */
/*    input   : xold,pfac,ppen,beztyp,xc,gc,l,h                       */
/*    output  : sn,sc,xc,gc,fp,d,h                                    */
/*    working : gp,c,l(n+1:),s,y,t                                    */
/*    ------------------------------------------------------------    */
/*o   sn(n) = newton direction for idir = 3,4                         */
/*o   sc(n) = cauchy direction for idir = 4                           */
/*o   sc(n) = conjugate direction  for idir = 1,2                     */
/*o   sc(n) = univariate direction for idir = 0                       */
/*    ============================================================    */
      maheps(&epsmah);
      vm=beztyp[4];
      istep=it-1;                          /* istep=0:maxs-1 */
      if(idir <= 0) {
        for(i=0; i<n; i++) {
          sc[i]=0.0;
        }
        k=istep%n;
        sc[k]=0.01*fabs(xold[k]);          /* univariate method */
        if(sc[k] == 0.0) sc[k]=0.01;
      } else if(idir == 1) {
        fdgrad(nx,ns,ne,n,xold,pfac,ppen,c,fp,epsmah,gp);
        fr(n,xold,gc,gp,sc,istep);         /* fletcher-reeves method */
      } else if(idir == 2) {
        fdgrad(nx,ns,ne,n,xold,pfac,ppen,c,fp,epsmah,gp);
        pr(n,xold,gc,gp,sc,istep);         /* polak-ribiere method */
        for(i=0; i<n; i++) {
          gc[i]=gp[i];
        }
      } else {                             /* quasi-newton method */
        fdgrad(nx,ns,ne,n,xold,pfac,ppen,c,fp,epsmah,gp);
        if(istep > 0)
        bfgslg(n,xc,xold,gc,gp,epsmah,epsmah,angrad,d,l,h,s,y,t,vm);
        findsn(n,sn,gp,d,l,h,t,maxa,maxn);
/*      if(idir == 4) findsc(n,sn,sc,gp,d,l,h); *//* bezier c(gfmlag) */
        for(i=0; i<n; i++) {
          if(idir == 4) sc[i]=gp[i];              /* bezier c(gfnlag) */
          xc[i]=xold[i];
          gc[i]=gp[i];
        }
        printv(sn,n,"sn3");
      }
      return(0);
}
/**********************************************************************/
      int findsn(int n,double sn[],double gp[],double d[]
                ,int l[],double h[],double t[],int maxa,int maxn) {
/*    int findsn(n,sn,gp,d,l,h,t,maxa,maxn)
      double sn[],gp[],d[],h[],t[]; int n,l[],maxa,maxn; {            */
/*    ============================================================    */
/*    dimension sn(n),gp(n),d(n),l(maxn),h(1),t(maxa)                 */
      int i,j,nn,nt,nsd; int hsdecp(),hssolx();
/*    ============================================================    */
/*    compute newton point xn = xold + sn                             */
/*    ------------------------------------------------------------    */
/*    input : n,gp,l(n),h; output : sn,d; working : l(n+1:),t(maxa)   */
/*    ============================================================    */
      for(j=0; j<l[n-1]+n; j++) {
        t[j]=h[j];
      }
      for(i=0; i<n; i++) {
        sn[i]=gp[i];
      }
      printv(sn,n,"sn4");
      printv(t,l[n-1]+n,"h");
/*    +----------------------------------------------------------+    */
/*    | solve [h] {sn} = {gp}                                    |    */
/*    +----------------------------------------------------------+    */
      hsdecp(t,l,n,&nn,&nsd,maxa,maxn,d);
      nt=l[nn-1]+nn;
      printv(t,nt,"b");
      if(nt+nn > maxa) {printf("\n findsn : nt+nn > maxa"); exit(1);}
      hssolx(t,sn,l,n,nn,&t[nt]);
      printv(t,nt,"b");
      printv(&t[nt],nn,"sn");
      printv(sn,n,"sn5");
      return(0);
}
/**********************************************************************/
      int findsc(int n,double sn[],double sc[],double gp[]
                ,double d[],int l[],double h[]) {
/*    int findsc(n,sn,sc,gp,d,l,h)
      double sn[],sc[],gp[],d[],h[]; int n,l[]; {                     */
/*    ============================================================    */
      double r,xx,gg,gj; int i,j,jh;
/*    ============================================================    */
/*    compute cauchy point xc = xold + sc                             */
/*    ------------------------------------------------------------    */
/*    input : n,sn(n),gp(n),d(n),l(n),h(*);  output : sc(n)           */
/*    ============================================================    */
      for(i=0; i<n; i++) {
        sc[i]=gp[i]-d[i]*sn[i];      /* gp + d * (xp - xn) */
      }
/*    +----------------------------------------------------------+    */
/*    | gg = <g>{g} ;  xx = <g>[h]{g}/2                          |    */
/*    +----------------------------------------------------------+    */
      gg=sc[0]*sc[0];
      xx=sc[0]*h[0]*sc[0]*0.5;
      for(j=1; j<n; j++) {
        jh=l[j];
        gj=sc[j];
        gg=gg+gj*gj;
        for(i=j-jh+l[j-1]; i<j; i++) {
          xx=xx+sc[i]*h[i+jh]*gj;
        }
        xx=xx+gj*(h[j+jh]+d[j])*gj*0.5;
      }
/*    +----------------------------------------------------------+    */
/*    | sc = xc - xp = -(0.5*gg/xx) {{gp} + [d] * {xp - xn}}     |    */
/*    +----------------------------------------------------------+    */
      r=-0.5*gg/xx;
      for(i=0; i<n; i++) {
        sc[i]=r*sc[i];
      }
      return(0);
}
/**********************************************************************/
      int maheps(double *epsmah) {
/*    int maheps(epsmah) double *epsmah; {                            */
/*    ============================================================    */
/*o   epsmah = machine epsilon                                        */
/*    ============================================================    */
      *epsmah=1;
      do {
        *epsmah=*epsmah*0.5;
      } while((*epsmah+1.0)-1.0 > 0);
      *epsmah=*epsmah*2.0;
      if(*epsmah < 1.0e-18) *epsmah=*epsmah*2048;
      return(0);
}
/**********************************************************************/
      int printv(double a[],int n,char *msg) {
/*    int printv(a,n,msg) double a[]; int n; char *msg; {             */
/*    ============================================================    */
      int i;
/*    ============================================================    */
      printf("\n %s",msg);
      for(i=0; i<n; i++) {
        if(i%6 == 0) printf("\n");
        printf("%13.5le",a[i]);
      }
      return(0);
}
/**********************************************************************/
