#include <stdio.h>
#include <ctype.h>
int freeii(int *, FILE *);
/**********************************************************************/
      main(int argc,char **argv) { /* char **envp */
/*    ============================================================    */
      FILE *fopen(),*fp_r,*fp_w;
      int  a[10000],ndim=10000;
      int  np,nn,nd,nl,n1,n2,n3,n4,n5,n6,n7,n8,n9,na;
/*    ============================================================    */
      if(argc<3) {printf("Usage : mkmain infile outfile"); exit(-1);}
      if((fp_r=fopen(argv[1],"r"))==NULL) exit(-1);
      if((fp_w=fopen(argv[2],"w"))==NULL) exit(-1);
/*    ------------------------------------------------------------    */
 L100:freeii(&np,fp_r); freeii(&nn,fp_r); freeii(&nd,NULL);
      if(np == 0 || nn == 0) exit(0);
      if(nd <= 0) nd=1;
      nl=np-nn+nd;
/*    ------------------------------------------------------------    */
      n1=0;
      n2=n1+2*np;      /* nopp(2,np) */
      n3=n2+nn+1;      /* ponp(nn+1) */
      n4=n3+2*np;      /* pons(2*np) */
      n5=n4+nl+1;      /* polp(nl+1) */
      n6=ndim-4*nn;    /* pols(*) unknown */
      n7=n6+nn;        /* ponu(nn) */
      n8=n7+nn;        /* lvsn(nn) */
      n9=n8+nn;        /* lvsp(nn) */
/*    na=n9+nn;    */  /* lvsb(nn) */
/*    ------------------------------------------------------------    */
      mkinp (&a[n1],np,fp_r);
      mkloop(&a[n1],&a[n2],&a[n3],&a[n4],&a[n5]
                   ,&a[n6],&a[n7],&a[n8],&a[n9],np,nn,nl);
      mkout (&a[n2],&a[n3],&a[n4],&a[n5],nn,nl,fp_w);
      if(n5+a[n4+nl] > n6) {printf("\n array too small"); exit(1);}
      goto L100;
}
/**********************************************************************/
      int mkinp(int nopp[],int np,FILE *fp_r) {
/*    int mkinp(nopp,np,fp_r) int nopp[],np; FILE *fp_r; {            */
/*    ============================================================    */
      int ip,ipinp;
      nopp-=3;
/*    ============================================================    */
      for(ip=1; ip<=np; ip++) {
        freeii(&ipinp,fp_r);
        if(ip != ipinp) printf("\n ip not in sequence");
        freeii(&nopp[1+ip*2],fp_r); freeii(&nopp[2+ip*2],fp_r);
      }
      return(0);
}
/**********************************************************************/
      int mkout(int ponp[],int pons[]
               ,int polp[],int pols[],int nn,int nl,FILE *fp_w) {
/*    int mkout(ponp,pons,polp,pols,nn,nl,fp_w)
      int ponp[],pons[],polp[],pols[],nn,nl; FILE *fp_w; {            */
/*    ============================================================    */
      int in,il,ip,ipbg,iped;
      --ponp; --pons; --polp; --pols;
/*    ============================================================    */
      for(in=1; in<=nn; in++) {
        ipbg=ponp[in];
        iped=ponp[in+1]-1;
        fprintf(fp_w,"\n%5d",in);
        for(ip=ipbg; ip<=iped; ip++) fprintf(fp_w,"%5d",pons[ip]);
      }
/*    ------------------------------------------------------------    */
      for(il=1; il<=nl; il++) {
        ipbg=polp[il];
        iped=polp[il+1]-1;
        fprintf(fp_w,"\n%5d",il);
        for(ip=ipbg; ip<=iped; ip++) fprintf(fp_w,"%5d",pols[ip]);
      }
      fprintf(fp_w,"\n");
      return(0);
}
/**********************************************************************/
